package com.isu.gaswellwatch.service;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.IService;
import com.isu.gaswellwatch.dto.LoginDTO;
import com.isu.gaswellwatch.dto.ModifyPasswordDTO;
import com.isu.gaswellwatch.dto.UserDTO;
import com.isu.gaswellwatch.dto.UserEditDTO;
import com.isu.gaswellwatch.entity.User;
import com.isu.gaswellwatch.vo.MenuTreeVO;
import com.isu.gaswellwatch.vo.MenuVO;
import com.isu.gaswellwatch.vo.UserLoginInfoVO;
import com.isu.gaswellwatch.vo.UserVO;
import jakarta.servlet.http.HttpServletResponse;

import java.util.List;

public interface UserService extends IService<User> {

    UserLoginInfoVO doLogin(LoginDTO loginDTO);
    List<MenuTreeVO> getMenuTreeByToken();
    void logout();
    void modifyPassword(ModifyPasswordDTO modifyPasswordDTO);
    Page<UserVO> page(Integer currentPage, Integer pageSize, String username, String name, Long roleId, String isEnable);
    void add(UserDTO userDTO);
    void edit(UserEditDTO userEditDTO);
    UserVO getUser(Long id);
    void delete(Long id);
    void reset(Long id);
    void export(HttpServletResponse response, String username, String name, Long roleId, String isEnable);
    void setEnable(Long userId, String isEnable);
    List<MenuVO> getMenuList(String username);

    UserVO selectUserInfo(String usernamee);
}
