/*
 Navicat Premium Data Transfer

 Source Server         : localhostMysql
 Source Server Type    : MySQL
 Source Server Version : 80034
 Source Host           : localhost:3306
 Source Schema         : gaswellwatch

 Target Server Type    : MySQL
 Target Server Version : 80034
 File Encoding         : 65001

 Date: 26/11/2024 03:09:15
*/

SET NAMES utf8mb4;
SET FOREIGN_KEY_CHECKS = 0;

-- ----------------------------
-- Table structure for block
-- ----------------------------
DROP TABLE IF EXISTS `block`;
CREATE TABLE `block` (
                         `id` bigint NOT NULL COMMENT '主键',
                         `name` varchar(100) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci NOT NULL COMMENT '名称',
                         `details` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci DEFAULT NULL COMMENT '描述',
                         `create_time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间',
                         `update_time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '更新时间',
                         PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci ROW_FORMAT=DYNAMIC COMMENT='区块管理';

-- ----------------------------
-- Records of block
-- ----------------------------
BEGIN;
INSERT INTO `block` (`id`, `name`, `details`, `create_time`, `update_time`) VALUES (1860217436825976832, '桃7', '测试用', '2024-11-23 15:02:52', '2024-11-23 15:02:52');
INSERT INTO `block` (`id`, `name`, `details`, `create_time`, `update_time`) VALUES (1860217990331498496, '苏5', '测试用', '2024-11-23 15:05:04', '2024-11-23 15:05:04');
INSERT INTO `block` (`id`, `name`, `details`, `create_time`, `update_time`) VALUES (1860218019209281536, '苏46', '测试用', '2024-11-23 15:05:11', '2024-11-23 15:05:11');
INSERT INTO `block` (`id`, `name`, `details`, `create_time`, `update_time`) VALUES (1860233760696434688, '苏59', '测试用', '2024-11-23 16:07:44', '2024-11-23 16:07:44');
COMMIT;

-- ----------------------------
-- Table structure for block_department
-- ----------------------------
DROP TABLE IF EXISTS `block_department`;
CREATE TABLE `block_department` (
                                    `id` bigint NOT NULL COMMENT '主键',
                                    `block_id` bigint NOT NULL,
                                    `department_id` bigint NOT NULL,
                                    `create_time` timestamp NULL DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间',
                                    `update_time` timestamp NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '更新时间',
                                    PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci COMMENT='区块部门关联表';

-- ----------------------------
-- Records of block_department
-- ----------------------------
BEGIN;
INSERT INTO `block_department` (`id`, `block_id`, `department_id`, `create_time`, `update_time`) VALUES (1860217436872114176, 1860217436825976832, 1, '2024-11-23 15:02:52', '2024-11-23 15:02:52');
INSERT INTO `block_department` (`id`, `block_id`, `department_id`, `create_time`, `update_time`) VALUES (1860217990339887104, 1860217990331498496, 1, '2024-11-23 15:05:04', '2024-11-23 15:05:04');
INSERT INTO `block_department` (`id`, `block_id`, `department_id`, `create_time`, `update_time`) VALUES (1860218019217670144, 1860218019209281536, 1, '2024-11-23 15:05:11', '2024-11-23 15:05:11');
INSERT INTO `block_department` (`id`, `block_id`, `department_id`, `create_time`, `update_time`) VALUES (1860233760709017600, 1860233760696434688, 2, '2024-11-23 16:07:44', '2024-11-23 16:07:44');
COMMIT;

-- ----------------------------
-- Table structure for command_points
-- ----------------------------
DROP TABLE IF EXISTS `command_points`;
CREATE TABLE `command_points` (
                                  `id` bigint NOT NULL COMMENT '主键',
                                  `command_id` bigint DEFAULT NULL COMMENT '对应指令标识',
                                  `device_id` bigint DEFAULT NULL COMMENT '使用设备标识',
                                  `field` varchar(100) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci DEFAULT NULL COMMENT '采集后转换字段名称',
                                  `name` varchar(100) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci DEFAULT NULL COMMENT '采集后显示名称',
                                  `details` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci DEFAULT NULL COMMENT '描述',
                                  `start_address` int DEFAULT NULL COMMENT '起始位置',
                                  `step_size` int DEFAULT '1' COMMENT '读取长度',
                                  `factor` decimal(10,2) DEFAULT NULL COMMENT '系数，正数：除以，负数：乘以',
                                  `precision` tinyint DEFAULT NULL COMMENT '小数点位数',
                                  `format` varchar(100) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci DEFAULT NULL COMMENT '组合方式',
                                  `decode_name` varchar(100) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci DEFAULT NULL COMMENT '解析器名称',
                                  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci ROW_FORMAT=DYNAMIC COMMENT='指令点表';

-- ----------------------------
-- Records of command_points
-- ----------------------------
BEGIN;
INSERT INTO `command_points` (`id`, `command_id`, `device_id`, `field`, `name`, `details`, `start_address`, `step_size`, `factor`, `precision`, `format`, `decode_name`) VALUES (10000, 10001, 1, 'deviceTime', '设备系统时间', NULL, 0, 6, NULL, NULL, '%s-%s-%s %s:%s:%s', 'localDateTime');
INSERT INTO `command_points` (`id`, `command_id`, `device_id`, `field`, `name`, `details`, `start_address`, `step_size`, `factor`, `precision`, `format`, `decode_name`) VALUES (10001, 10001, 1, 'runMode', '当前运行模式', NULL, 6, 1, NULL, NULL, NULL, NULL);
INSERT INTO `command_points` (`id`, `command_id`, `device_id`, `field`, `name`, `details`, `start_address`, `step_size`, `factor`, `precision`, `format`, `decode_name`) VALUES (10002, 10001, 1, 'wellStatus', '气井状态', NULL, 7, 1, NULL, NULL, NULL, NULL);
INSERT INTO `command_points` (`id`, `command_id`, `device_id`, `field`, `name`, `details`, `start_address`, `step_size`, `factor`, `precision`, `format`, `decode_name`) VALUES (10003, 10001, 1, 'plugStatus', '柱塞状态', NULL, 8, 1, NULL, NULL, NULL, NULL);
INSERT INTO `command_points` (`id`, `command_id`, `device_id`, `field`, `name`, `details`, `start_address`, `step_size`, `factor`, `precision`, `format`, `decode_name`) VALUES (10004, 10001, 1, 'statusOpenTime', '当前状态开始时间', NULL, 9, 3, NULL, NULL, '%s:%s:%s', 'localTime');
INSERT INTO `command_points` (`id`, `command_id`, `device_id`, `field`, `name`, `details`, `start_address`, `step_size`, `factor`, `precision`, `format`, `decode_name`) VALUES (10005, 10001, 1, 'statusCloseTime', '当前状态剩余时长', NULL, 12, 3, NULL, NULL, '%s:%s:%s', 'localTime');
INSERT INTO `command_points` (`id`, `command_id`, `device_id`, `field`, `name`, `details`, `start_address`, `step_size`, `factor`, `precision`, `format`, `decode_name`) VALUES (10006, 10001, 1, 'oilPressure', '油压', NULL, 15, 1, 100.00, 2, NULL, 'factor');
INSERT INTO `command_points` (`id`, `command_id`, `device_id`, `field`, `name`, `details`, `start_address`, `step_size`, `factor`, `precision`, `format`, `decode_name`) VALUES (10007, 10001, 1, 'casPressure', '套压', NULL, 16, 1, 100.00, 2, NULL, 'factor');
INSERT INTO `command_points` (`id`, `command_id`, `device_id`, `field`, `name`, `details`, `start_address`, `step_size`, `factor`, `precision`, `format`, `decode_name`) VALUES (10008, 10001, 1, 'prePressure', '输压', NULL, 17, 1, 100.00, 2, NULL, 'factor');
INSERT INTO `command_points` (`id`, `command_id`, `device_id`, `field`, `name`, `details`, `start_address`, `step_size`, `factor`, `precision`, `format`, `decode_name`) VALUES (10009, 10001, 1, 'pipePressure', '管压', NULL, 18, 1, 100.00, 2, NULL, 'factor');
INSERT INTO `command_points` (`id`, `command_id`, `device_id`, `field`, `name`, `details`, `start_address`, `step_size`, `factor`, `precision`, `format`, `decode_name`) VALUES (10010, 10001, 1, 'liquidLevel', '液位', NULL, 19, 1, 1000.00, 3, NULL, 'factor');
INSERT INTO `command_points` (`id`, `command_id`, `device_id`, `field`, `name`, `details`, `start_address`, `step_size`, `factor`, `precision`, `format`, `decode_name`) VALUES (10011, 10001, 1, 'temperature', '温度', NULL, 20, 1, NULL, NULL, NULL, '温度：单位℃，*100，最高位表示正负，0正1负,即零下的温度加32768');
INSERT INTO `command_points` (`id`, `command_id`, `device_id`, `field`, `name`, `details`, `start_address`, `step_size`, `factor`, `precision`, `format`, `decode_name`) VALUES (10012, 10001, 1, 'humidity', '湿度', NULL, 21, 1, 100.00, 2, NULL, 'factor');
INSERT INTO `command_points` (`id`, `command_id`, `device_id`, `field`, `name`, `details`, `start_address`, `step_size`, `factor`, `precision`, `format`, `decode_name`) VALUES (10013, 10002, 1, 'opmode', '运行模式', NULL, 100, 1, NULL, NULL, NULL, NULL);
INSERT INTO `command_points` (`id`, `command_id`, `device_id`, `field`, `name`, `details`, `start_address`, `step_size`, `factor`, `precision`, `format`, `decode_name`) VALUES (10014, 10002, 1, 'timer1', '定时器1使能', NULL, 110, 1, NULL, NULL, NULL, NULL);
INSERT INTO `command_points` (`id`, `command_id`, `device_id`, `field`, `name`, `details`, `start_address`, `step_size`, `factor`, `precision`, `format`, `decode_name`) VALUES (10015, 10002, 1, 'timer2', '定时器2使能', NULL, 111, 1, NULL, NULL, NULL, NULL);
INSERT INTO `command_points` (`id`, `command_id`, `device_id`, `field`, `name`, `details`, `start_address`, `step_size`, `factor`, `precision`, `format`, `decode_name`) VALUES (10016, 10002, 1, 'timer3', '定时器3使能', NULL, 112, 1, NULL, NULL, NULL, NULL);
INSERT INTO `command_points` (`id`, `command_id`, `device_id`, `field`, `name`, `details`, `start_address`, `step_size`, `factor`, `precision`, `format`, `decode_name`) VALUES (10017, 10002, 1, 'timer4', '定时器4使能', NULL, 113, 1, NULL, NULL, NULL, NULL);
INSERT INTO `command_points` (`id`, `command_id`, `device_id`, `field`, `name`, `details`, `start_address`, `step_size`, `factor`, `precision`, `format`, `decode_name`) VALUES (10018, 10002, 1, 'timer1Open', '定时器1开井时间', NULL, 114, 3, NULL, NULL, '%s:%s:%s', 'localTime');
INSERT INTO `command_points` (`id`, `command_id`, `device_id`, `field`, `name`, `details`, `start_address`, `step_size`, `factor`, `precision`, `format`, `decode_name`) VALUES (10019, 10002, 1, 'timer1Close', '定时器1关井时间', NULL, 117, 3, NULL, NULL, '%s:%s:%s', 'localTime');
INSERT INTO `command_points` (`id`, `command_id`, `device_id`, `field`, `name`, `details`, `start_address`, `step_size`, `factor`, `precision`, `format`, `decode_name`) VALUES (10020, 10002, 1, 'timer2Open', '定时器2开井时间', NULL, 120, 3, NULL, NULL, '%s:%s:%s', 'localTime');
INSERT INTO `command_points` (`id`, `command_id`, `device_id`, `field`, `name`, `details`, `start_address`, `step_size`, `factor`, `precision`, `format`, `decode_name`) VALUES (10021, 10002, 1, 'timer2Close', '定时器2关井时间', NULL, 123, 3, NULL, NULL, '%s:%s:%s', 'localTime');
INSERT INTO `command_points` (`id`, `command_id`, `device_id`, `field`, `name`, `details`, `start_address`, `step_size`, `factor`, `precision`, `format`, `decode_name`) VALUES (10022, 10002, 1, 'timer3Open', '定时器3开井时间', NULL, 126, 3, NULL, NULL, '%s:%s:%s', 'localTime');
INSERT INTO `command_points` (`id`, `command_id`, `device_id`, `field`, `name`, `details`, `start_address`, `step_size`, `factor`, `precision`, `format`, `decode_name`) VALUES (10023, 10002, 1, 'timer3Close', '定时器3关井时间', NULL, 129, 3, NULL, NULL, '%s:%s:%s', 'localTime');
INSERT INTO `command_points` (`id`, `command_id`, `device_id`, `field`, `name`, `details`, `start_address`, `step_size`, `factor`, `precision`, `format`, `decode_name`) VALUES (10024, 10002, 1, 'timer4Open', '定时器4开井时间', NULL, 132, 3, NULL, NULL, '%s:%s:%s', 'localTime');
INSERT INTO `command_points` (`id`, `command_id`, `device_id`, `field`, `name`, `details`, `start_address`, `step_size`, `factor`, `precision`, `format`, `decode_name`) VALUES (10025, 10002, 1, 'timer4Close', '定时器4关井时间', NULL, 135, 3, NULL, NULL, '%s:%s:%s', 'localTime');
INSERT INTO `command_points` (`id`, `command_id`, `device_id`, `field`, `name`, `details`, `start_address`, `step_size`, `factor`, `precision`, `format`, `decode_name`) VALUES (10026, 10002, 1, 'timingOpen', '计时器开井时长', NULL, 150, 3, NULL, NULL, '%s:%s:%s', 'stringTime');
INSERT INTO `command_points` (`id`, `command_id`, `device_id`, `field`, `name`, `details`, `start_address`, `step_size`, `factor`, `precision`, `format`, `decode_name`) VALUES (10027, 10002, 1, 'timingClose', '计时器关井时长', NULL, 153, 3, NULL, NULL, '%s:%s:%s', 'stringTime');
INSERT INTO `command_points` (`id`, `command_id`, `device_id`, `field`, `name`, `details`, `start_address`, `step_size`, `factor`, `precision`, `format`, `decode_name`) VALUES (10028, 10002, 1, 'timingCelay', '计时器延时时长', NULL, 157, 3, NULL, NULL, '%s:%s:%s', 'stringTime');
INSERT INTO `command_points` (`id`, `command_id`, `device_id`, `field`, `name`, `details`, `start_address`, `step_size`, `factor`, `precision`, `format`, `decode_name`) VALUES (10029, 10002, 1, 'presource', '压力模式压力源', NULL, 160, 1, NULL, NULL, NULL, NULL);
INSERT INTO `command_points` (`id`, `command_id`, `device_id`, `field`, `name`, `details`, `start_address`, `step_size`, `factor`, `precision`, `format`, `decode_name`) VALUES (10030, 10002, 1, 'pressureOpen', '压力模式开井压力', NULL, 161, 1, 100.00, 2, NULL, 'factor');
INSERT INTO `command_points` (`id`, `command_id`, `device_id`, `field`, `name`, `details`, `start_address`, `step_size`, `factor`, `precision`, `format`, `decode_name`) VALUES (10031, 10002, 1, 'pressureClose', '压力模式关井压力', NULL, 162, 1, 100.00, 2, NULL, 'factor');
INSERT INTO `command_points` (`id`, `command_id`, `device_id`, `field`, `name`, `details`, `start_address`, `step_size`, `factor`, `precision`, `format`, `decode_name`) VALUES (10032, 10002, 1, 'triggerType', '压力模式触发类型', NULL, 163, 1, NULL, NULL, NULL, NULL);
INSERT INTO `command_points` (`id`, `command_id`, `device_id`, `field`, `name`, `details`, `start_address`, `step_size`, `factor`, `precision`, `format`, `decode_name`) VALUES (10033, 10002, 1, 'stabilityTime', '压力稳定时间', NULL, 164, 1, NULL, NULL, NULL, NULL);
INSERT INTO `command_points` (`id`, `command_id`, `device_id`, `field`, `name`, `details`, `start_address`, `step_size`, `factor`, `precision`, `format`, `decode_name`) VALUES (10034, 10002, 1, 'maxOpenWell', '最大开井时长', NULL, 170, 3, NULL, NULL, '%s:%s:%s', 'stringTime');
INSERT INTO `command_points` (`id`, `command_id`, `device_id`, `field`, `name`, `details`, `start_address`, `step_size`, `factor`, `precision`, `format`, `decode_name`) VALUES (10035, 10002, 1, 'minOpenWell', '最小开井时长', NULL, 173, 3, NULL, NULL, '%s:%s:%s', 'stringTime');
INSERT INTO `command_points` (`id`, `command_id`, `device_id`, `field`, `name`, `details`, `start_address`, `step_size`, `factor`, `precision`, `format`, `decode_name`) VALUES (10036, 10002, 1, 'maxCloseWell', '最大关井时长', NULL, 176, 3, NULL, NULL, '%s:%s:%s', 'stringTime');
INSERT INTO `command_points` (`id`, `command_id`, `device_id`, `field`, `name`, `details`, `start_address`, `step_size`, `factor`, `precision`, `format`, `decode_name`) VALUES (10037, 10002, 1, 'minCloseWell', '最小关井时长', NULL, 179, 3, NULL, NULL, '%s:%s:%s', 'stringTime');
INSERT INTO `command_points` (`id`, `command_id`, `device_id`, `field`, `name`, `details`, `start_address`, `step_size`, `factor`, `precision`, `format`, `decode_name`) VALUES (10038, 10003, 1, 'presproTect', '开井压力保护使能', NULL, 320, 1, NULL, NULL, NULL, NULL);
INSERT INTO `command_points` (`id`, `command_id`, `device_id`, `field`, `name`, `details`, `start_address`, `step_size`, `factor`, `precision`, `format`, `decode_name`) VALUES (10039, 10003, 1, 'presproSource', '开井压力保护源', NULL, 321, 1, NULL, NULL, NULL, NULL);
INSERT INTO `command_points` (`id`, `command_id`, `device_id`, `field`, `name`, `details`, `start_address`, `step_size`, `factor`, `precision`, `format`, `decode_name`) VALUES (10040, 10003, 1, 'openWellLimitMax', '开井压力限制上限', NULL, 322, 1, 100.00, 2, NULL, 'factor');
INSERT INTO `command_points` (`id`, `command_id`, `device_id`, `field`, `name`, `details`, `start_address`, `step_size`, `factor`, `precision`, `format`, `decode_name`) VALUES (10041, 10003, 1, 'openWellLimitMin', '开井压力限制下限', NULL, 323, 1, 100.00, 2, NULL, 'factor');
INSERT INTO `command_points` (`id`, `command_id`, `device_id`, `field`, `name`, `details`, `start_address`, `step_size`, `factor`, `precision`, `format`, `decode_name`) VALUES (10042, 10003, 1, 'plugInitStatus', '柱塞模式初始气井状态', NULL, 348, 1, NULL, NULL, NULL, NULL);
INSERT INTO `command_points` (`id`, `command_id`, `device_id`, `field`, `name`, `details`, `start_address`, `step_size`, `factor`, `precision`, `format`, `decode_name`) VALUES (10043, 10003, 1, 'plugSustainTime', '柱塞模式续流时长', NULL, 349, 3, NULL, NULL, '%s:%s:%s', 'stringTime');
INSERT INTO `command_points` (`id`, `command_id`, `device_id`, `field`, `name`, `details`, `start_address`, `step_size`, `factor`, `precision`, `format`, `decode_name`) VALUES (10044, 10003, 1, 'plugCloseTime', '柱塞模式关井时长', NULL, 352, 3, NULL, NULL, '%s:%s:%s', 'stringTime');
INSERT INTO `command_points` (`id`, `command_id`, `device_id`, `field`, `name`, `details`, `start_address`, `step_size`, `factor`, `precision`, `format`, `decode_name`) VALUES (10045, 10003, 1, 'tpInitStatus', '时压模式初始气井状态', NULL, 375, 1, NULL, NULL, NULL, NULL);
INSERT INTO `command_points` (`id`, `command_id`, `device_id`, `field`, `name`, `details`, `start_address`, `step_size`, `factor`, `precision`, `format`, `decode_name`) VALUES (10046, 10003, 1, 'tpOpenSource', '时压模式开井源', NULL, 376, 1, NULL, NULL, NULL, NULL);
INSERT INTO `command_points` (`id`, `command_id`, `device_id`, `field`, `name`, `details`, `start_address`, `step_size`, `factor`, `precision`, `format`, `decode_name`) VALUES (10047, 10003, 1, 'tpOpenTrigger', '时压模式开井触发', NULL, 377, 1, NULL, NULL, NULL, NULL);
INSERT INTO `command_points` (`id`, `command_id`, `device_id`, `field`, `name`, `details`, `start_address`, `step_size`, `factor`, `precision`, `format`, `decode_name`) VALUES (10048, 10003, 1, 'tpOpenPressure', '时压模式开井压力', NULL, 378, 1, NULL, NULL, NULL, NULL);
INSERT INTO `command_points` (`id`, `command_id`, `device_id`, `field`, `name`, `details`, `start_address`, `step_size`, `factor`, `precision`, `format`, `decode_name`) VALUES (10049, 10003, 1, 'tpOpenTime', '时压模式开井时长', NULL, 379, 3, NULL, NULL, '%s:%s:%s', 'stringTime');
INSERT INTO `command_points` (`id`, `command_id`, `device_id`, `field`, `name`, `details`, `start_address`, `step_size`, `factor`, `precision`, `format`, `decode_name`) VALUES (10050, 10003, 1, 'tpCloseSource', '时压模式关井源', NULL, 382, 1, NULL, NULL, NULL, NULL);
INSERT INTO `command_points` (`id`, `command_id`, `device_id`, `field`, `name`, `details`, `start_address`, `step_size`, `factor`, `precision`, `format`, `decode_name`) VALUES (10051, 10003, 1, 'tpCloseTrigger', '时压模式关井触发', NULL, 383, 1, NULL, NULL, NULL, NULL);
INSERT INTO `command_points` (`id`, `command_id`, `device_id`, `field`, `name`, `details`, `start_address`, `step_size`, `factor`, `precision`, `format`, `decode_name`) VALUES (10052, 10003, 1, 'tpClosePressure', '时压模式关井压力', NULL, 384, 1, NULL, NULL, NULL, NULL);
INSERT INTO `command_points` (`id`, `command_id`, `device_id`, `field`, `name`, `details`, `start_address`, `step_size`, `factor`, `precision`, `format`, `decode_name`) VALUES (10053, 10003, 1, 'tpCloseTime', '时压模式关井时长', NULL, 385, 3, NULL, NULL, '%s:%s:%s', 'stringTime');
INSERT INTO `command_points` (`id`, `command_id`, `device_id`, `field`, `name`, `details`, `start_address`, `step_size`, `factor`, `precision`, `format`, `decode_name`) VALUES (10054, 10003, 1, 'tpStabilityTime', '时压模式压力稳定时长', NULL, 388, 1, NULL, NULL, NULL, NULL);
COMMIT;

-- ----------------------------
-- Table structure for commands
-- ----------------------------
DROP TABLE IF EXISTS `commands`;
CREATE TABLE `commands` (
                            `id` bigint NOT NULL COMMENT '主键',
                            `ref_type` varchar(20) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NOT NULL COMMENT '引用类型，DEVICE:设备；DEVICE_TYPE:设备类型',
                            `ref_id` bigint NOT NULL COMMENT '引用对象标识',
                            `name` varchar(100) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NOT NULL COMMENT '指令名称',
                            `code` varchar(100) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NOT NULL COMMENT '同一个设备唯一',
                            `type` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NOT NULL COMMENT '指令类型，COLLECTION:采集指令；CONTROL:控制指令；默认：采集指令。',
                            `collection_frequency` int DEFAULT NULL COMMENT '采集频率，默认30秒。采集类指令必填',
                            `command` varchar(100) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci DEFAULT NULL COMMENT '发送指令字符串',
                            `start_address` smallint DEFAULT NULL COMMENT '起始地址',
                            `message_length` smallint DEFAULT NULL COMMENT '返回消息长度',
                            `details` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci DEFAULT NULL COMMENT '指令描述',
                            PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci ROW_FORMAT=DYNAMIC COMMENT='指令表';

-- ----------------------------
-- Records of commands
-- ----------------------------
BEGIN;
INSERT INTO `commands` (`id`, `ref_type`, `ref_id`, `name`, `code`, `type`, `collection_frequency`, `command`, `start_address`, `message_length`, `details`) VALUES (10001, 'DEVICE', 1, '采集输入寄存器数据', 'GET_SYSTEM_INFO', 'COLLECTION', 30, '010400000016', 0, 98, '采集输入寄存器，从0000开始，连续采集22位');
INSERT INTO `commands` (`id`, `ref_type`, `ref_id`, `name`, `code`, `type`, `collection_frequency`, `command`, `start_address`, `message_length`, `details`) VALUES (10002, 'DEVICE', 1, '采集运行模式数据', 'GET_RUN_MODE', 'COLLECTION', 30, '010300640052', 100, 338, '采集保持寄存器，0100的值');
INSERT INTO `commands` (`id`, `ref_type`, `ref_id`, `name`, `code`, `type`, `collection_frequency`, `command`, `start_address`, `message_length`, `details`) VALUES (10003, 'DEVICE', 1, '采集气井状态数据', 'GET_WELL_STATUS_INFO', 'COLLECTION', 30, '010301400045', 320, 286, '采集气井状态数据，从320开始，连续采集69位');
INSERT INTO `commands` (`id`, `ref_type`, `ref_id`, `name`, `code`, `type`, `collection_frequency`, `command`, `start_address`, `message_length`, `details`) VALUES (10100, 'DEVICE', 2, '开井', 'OPEN_WELL', 'CONTROL', NULL, '01050000FF00', NULL, 16, NULL);
INSERT INTO `commands` (`id`, `ref_type`, `ref_id`, `name`, `code`, `type`, `collection_frequency`, `command`, `start_address`, `message_length`, `details`) VALUES (10101, 'DEVICE', 2, '关井', 'CLOSE_WELL', 'CONTROL', NULL, '010500000000', NULL, 16, NULL);
INSERT INTO `commands` (`id`, `ref_type`, `ref_id`, `name`, `code`, `type`, `collection_frequency`, `command`, `start_address`, `message_length`, `details`) VALUES (10102, 'DEVICE', 2, '采集系统信息', 'COLLECTION_SYSTEM_INFO', 'COLLECTION', 30, '010300000014', NULL, 90, '从0000开始，连续采集20位');
COMMIT;

-- ----------------------------
-- Table structure for department
-- ----------------------------
DROP TABLE IF EXISTS `department`;
CREATE TABLE `department` (
                              `id` bigint NOT NULL,
                              `name` varchar(255) DEFAULT NULL COMMENT '公司名称',
                              `description` varchar(500) DEFAULT NULL COMMENT '描述',
                              `create_time` timestamp NULL DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间',
                              `update_time` timestamp NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '更新时间',
                              `code` varchar(100) DEFAULT NULL COMMENT '公司编号',
                              PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci COMMENT='部门管理\n';

-- ----------------------------
-- Records of department
-- ----------------------------
BEGIN;
INSERT INTO `department` (`id`, `name`, `description`, `create_time`, `update_time`, `code`) VALUES (1, '第一业务部', '无', '2024-11-17 01:11:07', '2024-11-17 01:11:07', '0001');
INSERT INTO `department` (`id`, `name`, `description`, `create_time`, `update_time`, `code`) VALUES (2, '第二业务部', '无', '2024-11-17 01:11:21', '2024-11-17 01:11:21', '0002');
INSERT INTO `department` (`id`, `name`, `description`, `create_time`, `update_time`, `code`) VALUES (1859299142728155136, 'dasd', '2', '2024-11-21 02:13:54', '2024-11-21 02:13:54', '2');
COMMIT;

-- ----------------------------
-- Table structure for device
-- ----------------------------
DROP TABLE IF EXISTS `device`;
CREATE TABLE `device` (
                          `id` bigint NOT NULL AUTO_INCREMENT COMMENT '主键（取真实设备id）',
                          `device_type` bigint NOT NULL COMMENT '设备类型',
                          `code` varchar(100) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci NOT NULL COMMENT '设备编号',
                          `gas_station` varchar(100) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci DEFAULT NULL COMMENT '集气站',
                          `product` bigint DEFAULT NULL COMMENT '设备品牌',
                          `gateway_sn` varchar(100) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci DEFAULT NULL COMMENT '网关通讯地址',
                          `gas_well` bigint DEFAULT NULL COMMENT '气井ID',
                          `details` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci DEFAULT NULL COMMENT '描述',
                          `create_time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间',
                          `update_time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '更新时间',
                          PRIMARY KEY (`id`) USING BTREE,
                          KEY `gas_well_index` (`gas_well`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=5 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci ROW_FORMAT=DYNAMIC COMMENT='设备列表';

-- ----------------------------
-- Records of device
-- ----------------------------
BEGIN;
COMMIT;

-- ----------------------------
-- Table structure for device_types
-- ----------------------------
DROP TABLE IF EXISTS `device_types`;
CREATE TABLE `device_types` (
                                `id` bigint NOT NULL AUTO_INCREMENT COMMENT '主键',
                                `name` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci NOT NULL COMMENT '名称',
                                PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci ROW_FORMAT=DYNAMIC COMMENT='设备类型';

-- ----------------------------
-- Records of device_types
-- ----------------------------
BEGIN;
COMMIT;

-- ----------------------------
-- Table structure for dictionary
-- ----------------------------
DROP TABLE IF EXISTS `dictionary`;
CREATE TABLE `dictionary` (
                              `id` bigint NOT NULL,
                              `type` varchar(50) NOT NULL COMMENT '字典数据类型',
                              `code` varchar(50) NOT NULL COMMENT '编码',
                              `name` varchar(50) NOT NULL COMMENT '中文名称',
                              `value` varchar(50) NOT NULL COMMENT '字典值',
                              `sort` smallint NOT NULL COMMENT '排序',
                              `create_time` timestamp NULL DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间',
                              `update_time` timestamp NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '更新时间',
                              PRIMARY KEY (`id`),
                              KEY `type_index` (`type`) USING BTREE,
                              KEY `type_code_index` (`type`,`code`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci COMMENT='系统字典表';

-- ----------------------------
-- Records of dictionary
-- ----------------------------
BEGIN;
INSERT INTO `dictionary` (`id`, `type`, `code`, `name`, `value`, `sort`, `create_time`, `update_time`) VALUES (1, 'deviceType', 'zsqj', '柱塞气举', '1', 1, '2024-11-24 17:31:24', '2024-11-26 02:43:18');
INSERT INTO `dictionary` (`id`, `type`, `code`, `name`, `value`, `sort`, `create_time`, `update_time`) VALUES (2, 'deviceType', 'zdjk', '自动间开', '2', 2, '2024-11-24 17:32:23', '2024-11-26 02:43:20');
INSERT INTO `dictionary` (`id`, `type`, `code`, `name`, `value`, `sort`, `create_time`, `update_time`) VALUES (3, 'deviceType', 'znpp', '智能泡排', '3', 3, '2024-11-24 17:32:48', '2024-11-26 02:43:22');
INSERT INTO `dictionary` (`id`, `type`, `code`, `name`, `value`, `sort`, `create_time`, `update_time`) VALUES (4, 'deviceProduct', 'knpc', 'KNPC', '1', 1, '2024-11-24 17:39:52', '2024-11-26 02:43:23');
INSERT INTO `dictionary` (`id`, `type`, `code`, `name`, `value`, `sort`, `create_time`, `update_time`) VALUES (5, 'deviceProduct', 'etc', 'ETC', '2', 2, '2024-11-24 17:40:32', '2024-11-26 02:43:24');
INSERT INTO `dictionary` (`id`, `type`, `code`, `name`, `value`, `sort`, `create_time`, `update_time`) VALUES (6, 'deviceProduct', 'scss', '四川双晟', '3', 3, '2024-11-24 17:41:41', '2024-11-26 02:43:26');
INSERT INTO `dictionary` (`id`, `type`, `code`, `name`, `value`, `sort`, `create_time`, `update_time`) VALUES (7, 'runMode', 'handMode', '手动模式', '0', 0, '2024-11-25 18:03:41', '2024-11-26 02:43:28');
INSERT INTO `dictionary` (`id`, `type`, `code`, `name`, `value`, `sort`, `create_time`, `update_time`) VALUES (8, 'runMode', 'timerMode', '定时器模式', '1', 1, '2024-11-25 18:04:08', '2024-11-26 02:43:29');
INSERT INTO `dictionary` (`id`, `type`, `code`, `name`, `value`, `sort`, `create_time`, `update_time`) VALUES (9, 'runMode', 't2Mode', '计时器模式', '2', 2, '2024-11-25 18:04:39', '2024-11-26 02:43:30');
INSERT INTO `dictionary` (`id`, `type`, `code`, `name`, `value`, `sort`, `create_time`, `update_time`) VALUES (10, 'runMode', 'pressureMode', '压力模式', '3', 3, '2024-11-25 18:05:17', '2024-11-26 02:43:34');
INSERT INTO `dictionary` (`id`, `type`, `code`, `name`, `value`, `sort`, `create_time`, `update_time`) VALUES (11, 'runMode', 'pistonMode', '柱塞模式', '4', 4, '2024-11-25 18:05:39', '2024-11-26 02:43:36');
INSERT INTO `dictionary` (`id`, `type`, `code`, `name`, `value`, `sort`, `create_time`, `update_time`) VALUES (12, 'runMode', 'tpMode', '时压模式', '5', 5, '2024-11-25 18:06:08', '2024-11-26 02:43:37');
INSERT INTO `dictionary` (`id`, `type`, `code`, `name`, `value`, `sort`, `create_time`, `update_time`) VALUES (13, 'wellCtl', 'closeWell', '关井', '0', 0, '2024-11-25 18:07:10', '2024-11-26 02:43:39');
INSERT INTO `dictionary` (`id`, `type`, `code`, `name`, `value`, `sort`, `create_time`, `update_time`) VALUES (14, 'wellCtl', 'openWell', '开井', '1', 1, '2024-11-25 18:07:31', '2024-11-26 02:43:41');
INSERT INTO `dictionary` (`id`, `type`, `code`, `name`, `value`, `sort`, `create_time`, `update_time`) VALUES (15, 'plugStatus', 'leave', '离开', '0', 0, '2024-11-25 21:24:38', '2024-11-26 02:43:42');
INSERT INTO `dictionary` (`id`, `type`, `code`, `name`, `value`, `sort`, `create_time`, `update_time`) VALUES (16, 'plugStatus', 'riseing', '上升中', '1', 1, '2024-11-25 21:25:58', '2024-11-26 02:43:44');
INSERT INTO `dictionary` (`id`, `type`, `code`, `name`, `value`, `sort`, `create_time`, `update_time`) VALUES (17, 'plugStatus', 'reach', '到达', '2', 2, '2024-11-25 21:26:16', '2024-11-26 02:43:46');
COMMIT;

-- ----------------------------
-- Table structure for gas_well
-- ----------------------------
DROP TABLE IF EXISTS `gas_well`;
CREATE TABLE `gas_well` (
                            `id` bigint NOT NULL COMMENT '主键',
                            `name` varchar(100) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci NOT NULL COMMENT '气井名称',
                            `device_id` bigint DEFAULT NULL COMMENT '关联设备',
                            `block_id` bigint DEFAULT NULL COMMENT '所属区块ID',
                            `details` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci DEFAULT NULL COMMENT '描述',
                            `create_time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间',
                            `update_time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '更新时间',
                            PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci ROW_FORMAT=DYNAMIC COMMENT='气井管理';

-- ----------------------------
-- Records of gas_well
-- ----------------------------
BEGIN;
INSERT INTO `gas_well` (`id`, `name`, `device_id`, `block_id`, `details`, `create_time`, `update_time`) VALUES (1860586124699762688, '桃43', 2, 1860217436825976832, '测试123', '2024-11-24 15:28:01', '2024-11-25 15:58:50');
INSERT INTO `gas_well` (`id`, `name`, `device_id`, `block_id`, `details`, `create_time`, `update_time`) VALUES (1860588309223309312, '桃47', 4, 1860217436825976832, '测试13323', '2024-11-24 15:36:35', '2024-11-25 16:05:40');
INSERT INTO `gas_well` (`id`, `name`, `device_id`, `block_id`, `details`, `create_time`, `update_time`) VALUES (1860592296991391744, '苏64', NULL, 1860217990331498496, 'ceshi', '2024-11-24 15:52:26', '2024-11-24 15:52:26');
COMMIT;

-- ----------------------------
-- Table structure for menu
-- ----------------------------
DROP TABLE IF EXISTS `menu`;
CREATE TABLE `menu` (
                        `id` bigint NOT NULL,
                        `parent` bigint DEFAULT NULL COMMENT '父节点',
                        `name` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci DEFAULT NULL COMMENT '名称',
                        `code` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci DEFAULT NULL COMMENT '编码',
                        `icon` text CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci COMMENT '图标',
                        `sort` int DEFAULT '0' COMMENT '顺序',
                        `extra` longtext CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci COMMENT '外部数据',
                        `create_time` timestamp NULL DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间',
                        `update_time` timestamp NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '更新时间',
                        PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci COMMENT='菜单管理';

-- ----------------------------
-- Records of menu
-- ----------------------------
BEGIN;
INSERT INTO `menu` (`id`, `parent`, `name`, `code`, `icon`, `sort`, `extra`, `create_time`, `update_time`) VALUES (1834499936926826496, 0, '数据统计', 'summary', NULL, 2, '{\"url\":\"summary\",\"menuType\":{\"key\":\"4\",\"value\":\"\"}}', '2024-09-13 15:50:42', '2024-11-22 17:39:45');
INSERT INTO `menu` (`id`, `parent`, `name`, `code`, `icon`, `sort`, `extra`, `create_time`, `update_time`) VALUES (1834500910013743104, 0, '角色管理', 'roleManageList', NULL, 6, '{\"url\":\"roleManageList\",\"menuType\":{\"key\":\"4\",\"value\":\"\"}}', '2024-09-13 15:54:34', '2024-11-22 17:39:35');
INSERT INTO `menu` (`id`, `parent`, `name`, `code`, `icon`, `sort`, `extra`, `create_time`, `update_time`) VALUES (1834500987037941760, 0, '用户管理', 'userManage', NULL, 3, '{\"url\":\"userManage\",\"menuType\":{\"key\":\"4\",\"value\":\"\"}}', '2024-09-13 15:54:53', '2024-11-22 17:39:20');
INSERT INTO `menu` (`id`, `parent`, `name`, `code`, `icon`, `sort`, `extra`, `create_time`, `update_time`) VALUES (1834501029547212800, 0, '气井管理', 'gasManage', NULL, 1, '{\"url\":\"gasManage\",\"menuType\":{\"key\":\"4\",\"value\":\"\"}}', '2024-09-13 15:55:03', '2024-11-22 17:39:03');
INSERT INTO `menu` (`id`, `parent`, `name`, `code`, `icon`, `sort`, `extra`, `create_time`, `update_time`) VALUES (1834501061923045376, 0, '部门管理', 'agencyManage', NULL, 4, '{\"url\":\"agencyManage\",\"menuType\":{\"key\":\"4\",\"value\":\"\"}}', '2024-09-13 15:55:11', '2024-11-22 17:37:59');
INSERT INTO `menu` (`id`, `parent`, `name`, `code`, `icon`, `sort`, `extra`, `create_time`, `update_time`) VALUES (1834501113332629504, 0, '日志管理', 'logManage', NULL, 7, '{\"url\":\"logManage\",\"menuType\":{\"key\":\"4\",\"value\":\"\"}}', '2024-09-13 15:55:23', '2024-11-22 17:38:35');
INSERT INTO `menu` (`id`, `parent`, `name`, `code`, `icon`, `sort`, `extra`, `create_time`, `update_time`) VALUES (1834501151140085760, 0, '区块管理', 'areaManage', NULL, 5, '{\"url\":\"areaManage\",\"menuType\":{\"key\":\"4\",\"value\":\"\"}}', '2024-09-13 15:55:32', '2024-11-22 17:38:45');
INSERT INTO `menu` (`id`, `parent`, `name`, `code`, `icon`, `sort`, `extra`, `create_time`, `update_time`) VALUES (1834501183620775936, 0, '提醒记录', 'recordingManage', NULL, 8, '{\"url\":\"recordingManage\",\"menuType\":{\"key\":\"4\",\"value\":\"\"}}', '2024-09-13 15:55:40', '2024-11-22 17:37:46');
COMMIT;

-- ----------------------------
-- Table structure for role
-- ----------------------------
DROP TABLE IF EXISTS `role`;
CREATE TABLE `role` (
                        `id` bigint NOT NULL,
                        `name` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci DEFAULT NULL COMMENT '名称',
                        `description` varchar(500) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci DEFAULT NULL COMMENT '描述',
                        `create_time` timestamp NULL DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间',
                        `update_time` timestamp NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '更新时间',
                        PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci COMMENT='角色管理';

-- ----------------------------
-- Records of role
-- ----------------------------
BEGIN;
INSERT INTO `role` (`id`, `name`, `description`, `create_time`, `update_time`) VALUES (1, '超级管理员', '', '2024-08-20 11:36:35', '2024-11-22 17:53:40');
INSERT INTO `role` (`id`, `name`, `description`, `create_time`, `update_time`) VALUES (1836575681450868736, '测试角色', '', '2024-09-19 09:18:59', '2024-09-19 09:18:59');
INSERT INTO `role` (`id`, `name`, `description`, `create_time`, `update_time`) VALUES (1836581703372505088, '测试角色22', '测试角色2', '2024-09-19 09:42:54', '2024-09-19 09:55:03');
INSERT INTO `role` (`id`, `name`, `description`, `create_time`, `update_time`) VALUES (1836581757135093760, '测试角色234', '测试角色2', '2024-09-19 09:43:07', '2024-09-19 09:46:25');
INSERT INTO `role` (`id`, `name`, `description`, `create_time`, `update_time`) VALUES (1851162080074268672, '测试角色123', 'test', '2024-10-29 15:20:07', '2024-10-29 15:20:07');
INSERT INTO `role` (`id`, `name`, `description`, `create_time`, `update_time`) VALUES (1854116823323115520, '22222', '', '2024-11-06 19:01:13', '2024-11-06 19:01:13');
INSERT INTO `role` (`id`, `name`, `description`, `create_time`, `update_time`) VALUES (1854121363019661312, '3333', '', '2024-11-06 19:19:15', '2024-11-21 00:22:44');
COMMIT;

-- ----------------------------
-- Table structure for role_menu
-- ----------------------------
DROP TABLE IF EXISTS `role_menu`;
CREATE TABLE `role_menu` (
                             `id` bigint NOT NULL,
                             `role_id` bigint DEFAULT NULL COMMENT '角色id',
                             `menu_id` bigint DEFAULT NULL COMMENT '菜单id',
                             `identifier` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci DEFAULT NULL COMMENT '类型（0只能查,1可查可控,2编辑组态）',
                             `create_time` timestamp NULL DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间',
                             `update_time` timestamp NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '更新时间',
                             PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci COMMENT='角色菜单关联表';

-- ----------------------------
-- Records of role_menu
-- ----------------------------
BEGIN;
INSERT INTO `role_menu` (`id`, `role_id`, `menu_id`, `identifier`, `create_time`, `update_time`) VALUES (2, 1836575681450868736, 1834500910013743104, NULL, '2024-10-29 14:48:57', '2024-10-29 14:49:01');
INSERT INTO `role_menu` (`id`, `role_id`, `menu_id`, `identifier`, `create_time`, `update_time`) VALUES (1851162080078462976, 1851162080074268672, 1834500910013743104, NULL, '2024-10-29 15:20:07', '2024-10-29 15:20:07');
INSERT INTO `role_menu` (`id`, `role_id`, `menu_id`, `identifier`, `create_time`, `update_time`) VALUES (1854116823335698432, 1854116823323115520, 1834499936926826496, NULL, '2024-11-06 19:01:13', '2024-11-06 19:01:13');
INSERT INTO `role_menu` (`id`, `role_id`, `menu_id`, `identifier`, `create_time`, `update_time`) VALUES (1854116823335698433, 1854116823323115520, 1834501029547212800, NULL, '2024-11-06 19:01:13', '2024-11-06 19:01:13');
INSERT INTO `role_menu` (`id`, `role_id`, `menu_id`, `identifier`, `create_time`, `update_time`) VALUES (1854116823335698434, 1854116823323115520, 1834501061923045376, NULL, '2024-11-06 19:01:13', '2024-11-06 19:01:13');
INSERT INTO `role_menu` (`id`, `role_id`, `menu_id`, `identifier`, `create_time`, `update_time`) VALUES (1859271166338793472, 1854121363019661312, 1834500987037941760, NULL, '2024-11-21 00:22:44', '2024-11-21 00:22:44');
INSERT INTO `role_menu` (`id`, `role_id`, `menu_id`, `identifier`, `create_time`, `update_time`) VALUES (1859271166338793473, 1854121363019661312, 1834501029547212800, NULL, '2024-11-21 00:22:44', '2024-11-21 00:22:44');
INSERT INTO `role_menu` (`id`, `role_id`, `menu_id`, `identifier`, `create_time`, `update_time`) VALUES (1859271166338793474, 1854121363019661312, 1834501061923045376, NULL, '2024-11-21 00:22:44', '2024-11-21 00:22:44');
INSERT INTO `role_menu` (`id`, `role_id`, `menu_id`, `identifier`, `create_time`, `update_time`) VALUES (1859942446616543232, 1, 1834501029547212800, NULL, '2024-11-22 20:50:09', '2024-11-22 20:50:09');
INSERT INTO `role_menu` (`id`, `role_id`, `menu_id`, `identifier`, `create_time`, `update_time`) VALUES (1859942446616543233, 1, 1834499936926826496, NULL, '2024-11-22 20:50:09', '2024-11-22 20:50:09');
INSERT INTO `role_menu` (`id`, `role_id`, `menu_id`, `identifier`, `create_time`, `update_time`) VALUES (1859942446616543234, 1, 1834500987037941760, NULL, '2024-11-22 20:50:09', '2024-11-22 20:50:09');
INSERT INTO `role_menu` (`id`, `role_id`, `menu_id`, `identifier`, `create_time`, `update_time`) VALUES (1859942446616543235, 1, 1834501061923045376, NULL, '2024-11-22 20:50:09', '2024-11-22 20:50:09');
INSERT INTO `role_menu` (`id`, `role_id`, `menu_id`, `identifier`, `create_time`, `update_time`) VALUES (1859942446616543236, 1, 1834501151140085760, NULL, '2024-11-22 20:50:09', '2024-11-22 20:50:09');
INSERT INTO `role_menu` (`id`, `role_id`, `menu_id`, `identifier`, `create_time`, `update_time`) VALUES (1859942446616543237, 1, 1834500910013743104, NULL, '2024-11-22 20:50:09', '2024-11-22 20:50:09');
INSERT INTO `role_menu` (`id`, `role_id`, `menu_id`, `identifier`, `create_time`, `update_time`) VALUES (1859942446616543238, 1, 1834501113332629504, NULL, '2024-11-22 20:50:09', '2024-11-22 20:50:09');
INSERT INTO `role_menu` (`id`, `role_id`, `menu_id`, `identifier`, `create_time`, `update_time`) VALUES (1859942446616543239, 1, 1834501183620775936, NULL, '2024-11-22 20:50:09', '2024-11-22 20:50:09');
COMMIT;

-- ----------------------------
-- Table structure for t_device_data_1
-- ----------------------------
DROP TABLE IF EXISTS `t_device_data_1`;
CREATE TABLE `t_device_data_1` (
                                   `id` bigint NOT NULL COMMENT '主键',
                                   `device_id` int NOT NULL COMMENT '设备标识',
                                   `created_time` datetime NOT NULL COMMENT '数据落库时间',
                                   `collection_time` datetime NOT NULL COMMENT '采集指令下发时间',
                                   `receive_time` datetime NOT NULL COMMENT '接收到数据时间',
                                   `device_time` datetime DEFAULT NULL COMMENT '设备时间。\r\n寄存器地址：3:0000，3:0001，3:0002，3:0003，3:0004，3:0005\r\n',
                                   `run_mode` smallint DEFAULT NULL COMMENT '运行模式：\r\n0：手动模式  \r\n1：定时器模式  \r\n2：计时器模式  \r\n3：压力模式\r\n4：柱塞模式\r\n5：时压模式',
                                   `gas_status` smallint DEFAULT NULL COMMENT '气井状态：\r\n0：关闭 \r\n1：打开',
                                   `plug_status` smallint DEFAULT NULL COMMENT '柱塞状态：\r\n0：离开\r\n1：上升中\r\n2：到达',
                                   `status_start_time` time DEFAULT NULL COMMENT '当前状态开始时间',
                                   `status_end_time` time DEFAULT NULL COMMENT '当前状态结束时间',
                                   `oil_pressure` decimal(10,2) DEFAULT NULL COMMENT '油压：单位Mpa',
                                   `cas_pressure` decimal(10,2) DEFAULT NULL COMMENT '套压：单位Mpa',
                                   `pre_pressure` decimal(10,2) DEFAULT NULL COMMENT '输压：单位Mpa',
                                   `pipe_pressure` decimal(10,2) DEFAULT NULL COMMENT '管压：单位Mpa',
                                   `liquid_level` decimal(10,2) DEFAULT NULL COMMENT '流量：单位mm',
                                   `temperature` decimal(10,2) DEFAULT NULL COMMENT '温度：单位℃，*100，最高位表示正负，0正1负，即零下的温度加32768',
                                   `humidity` decimal(10,2) DEFAULT NULL COMMENT '湿度：单位%',
                                   `op_mode` smallint DEFAULT NULL COMMENT '运行模式：\r\n0： 手动模式  hand_mode\r\n1：定时器模式  timer_mode\r\n2：计时器模式  t2mode\r\n3：压力模式 pressure_mode\r\n4：柱塞模式 piston_mode\r\n5：时压模式 tp_mode',
                                   `timer_able1` smallint DEFAULT NULL COMMENT '定时模式定时器1使能：\r\n0：禁止 disable\r\n1：使能 enable',
                                   `timer_able2` smallint DEFAULT NULL COMMENT '定时模式定时器2使能：\r\n0：禁止 disable\r\n1：使能 ',
                                   `timer_open1` time DEFAULT NULL COMMENT '时0~23：分0~59：秒0~59',
                                   `timer_close1` time DEFAULT NULL COMMENT '时0~23：分0~59：秒0~59',
                                   `timer_open2` time DEFAULT NULL COMMENT '时0~23：分0~59：秒0~59',
                                   `timer_close2` time DEFAULT NULL COMMENT '时0~23：分0~59：秒0~59',
                                   `timing_open` varchar(10) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci DEFAULT NULL COMMENT '时0~23：分0~59：秒0~59',
                                   `timing_close` varchar(10) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci DEFAULT NULL COMMENT '时0~23：分0~59：秒0~59',
                                   `timing_delay` varchar(10) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci DEFAULT NULL COMMENT '时0~23：分0~59：秒0~59',
                                   `presource` smallint DEFAULT NULL COMMENT '触发压力源：\r\n0：油压 oil_pressure\r\n1：套压 cas_pressure\r\n2：输压 pre_pressure\r\n3：差压 diff_pressure',
                                   `pressure_open` decimal(10,2) DEFAULT NULL COMMENT '开井压力：单位Mpa，*100',
                                   `pressure_close` decimal(10,2) DEFAULT NULL COMMENT '关井压力： 单位Mpa，*100',
                                   `trigger_type` smallint DEFAULT NULL COMMENT '压力触发类型：\n0：大于开井压力开井、小于关井压力关井  gre_less\n1：大于开井压力开井、大于关井压力关井  gre_gre\n2：小于开井压力开井、小于关井压力关井  less_less\n3：小于开井压力开井、大于关井压力关井  less_gre',
                                   `stability_time` int DEFAULT NULL COMMENT '传感器压力稳定时间：秒',
                                   `max_open_well` varchar(10) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci DEFAULT NULL COMMENT '时0~999：分0~59：秒0~59',
                                   `max_close_well` varchar(10) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci DEFAULT NULL COMMENT '时0~999：分0~59：秒0~59',
                                   `min_open_well` varchar(10) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci DEFAULT NULL COMMENT '时0~999：分0~59：秒0~59',
                                   `min_close_well` varchar(10) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci DEFAULT NULL COMMENT '时0~999：分0~59：秒0~59',
                                   `prespro_tect` smallint DEFAULT NULL COMMENT '开井压力保护使能：\r\n0：禁止 disable\r\n1：使能 enable',
                                   `prespro_source` smallint DEFAULT NULL COMMENT '开井压力保护源：\r\n0：油压 oil_pressure\r\n1：套压 cas_pressure\r\n2：输压 pre_pressure\r\n3：差压 diff_pressure',
                                   `open_well_limit_max` decimal(10,2) DEFAULT NULL COMMENT '开井压力限制上限：单位MPa *100',
                                   `open_well_limit_min` decimal(10,2) DEFAULT NULL COMMENT '开井压力限制下限：单位MPa *100',
                                   `plug_init_status` smallint DEFAULT NULL COMMENT '柱塞模式初始气井状态：\r\n0：关井  close_well\r\n1：开井  open_well',
                                   `plug_sustain_time` varchar(10) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci DEFAULT NULL COMMENT '时0~999：分0~59：秒0~59',
                                   `plug_close_time` varchar(10) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci DEFAULT NULL COMMENT '时0~999：分0~59：秒0~59',
                                   `tp_init_status` smallint DEFAULT NULL COMMENT '时压模式初始气井状态：\r\n0：关井  close_well\r\n1：开井  open_well',
                                   `tp_open_source` smallint DEFAULT NULL COMMENT '时压模式开井源：\r\n0：油压 oil_pressure\r\n1：套压 cas_pressure\r\n2：输压 pre_pressure\r\n3：差压 diff_pressure\r\n4：时间 time_pressure',
                                   `tp_open_trigger` smallint DEFAULT NULL COMMENT '时压模式开井压力触发模式：\r\n0：大于压力触发\r\n1：小于压力触发',
                                   `tp_open_pressure` smallint DEFAULT NULL COMMENT '时压模式开井压力',
                                   `tp_open_time` varchar(10) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci DEFAULT NULL COMMENT '时0~999：分0~59：秒0~59',
                                   `tp_close_source` smallint DEFAULT NULL COMMENT '时压模式关井源：\r\n0：油压 oil_pressure\r\n1：套压 cas_pressure\r\n2：输压 pre_pressure\r\n3：差压 diff_pressure\r\n4：时间 time_pressure',
                                   `tp_close_trigger` smallint DEFAULT NULL COMMENT '时压模式关井压力触发模式：\r\n0：大于压力触发 max_pressure\r\n1：小于压力触发 min_pressure',
                                   `tp_close_pressure` smallint DEFAULT NULL COMMENT '时压模式关井压力',
                                   `tp_close_time` varchar(10) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci DEFAULT NULL COMMENT '时0~999：分0~59：秒0~59',
                                   `tp_stability_time` smallint DEFAULT NULL COMMENT '时压模式压力稳定时长：秒',
                                   PRIMARY KEY (`id`) USING BTREE,
                                   UNIQUE KEY `udx_device_create_time` (`device_id`,`collection_time`) USING BTREE COMMENT '设备采集数据唯一键'
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci ROW_FORMAT=DYNAMIC COMMENT='设备ID：1的采集数据';

-- ----------------------------
-- Records of t_device_data_1
-- ----------------------------
BEGIN;
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860882180582932480, 1, '2024-11-25 11:04:20', '2024-11-25 03:04:00', '2024-11-25 03:04:04', '2000-01-05 02:47:06', 2, 1, 0, '00:54:41', '00:05:19', 35.00, 35.00, 0.00, 0.00, 0.00, 2276.00, 8.90, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860882306382692352, 1, '2024-11-25 11:04:50', '2024-11-25 03:04:30', '2024-11-25 03:04:31', '2000-01-05 02:48:05', 2, 1, 0, '00:55:40', '00:04:20', 35.00, 35.00, 0.00, 0.00, 0.00, 2280.00, 8.82, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860882432207618048, 1, '2024-11-25 11:05:20', '2024-11-25 03:05:00', '2024-11-25 03:05:04', '2000-01-05 02:48:35', 2, 1, 0, '00:56:10', '00:03:50', 35.00, 35.00, 0.00, 0.00, 0.00, 2278.00, 8.79, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860882558036738048, 1, '2024-11-25 11:05:50', '2024-11-25 03:05:30', '2024-11-25 03:05:31', '2000-01-05 02:49:05', 2, 1, 0, '00:56:40', '00:03:20', 35.00, 35.00, 0.00, 0.00, 0.00, 2277.00, 8.77, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860882683865858048, 1, '2024-11-25 11:06:20', '2024-11-25 03:06:00', '2024-11-25 03:06:03', '2000-01-05 02:49:35', 2, 1, 0, '00:57:10', '00:02:50', 35.00, 35.00, 0.00, 0.00, 0.00, 2276.00, 8.78, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860882935519903744, 1, '2024-11-25 11:07:20', '2024-11-25 03:07:00', '2024-11-25 03:07:02', '2000-01-05 02:50:36', 2, 1, 0, '00:58:11', '00:01:49', 35.00, 35.00, 0.00, 0.00, 0.00, 2272.00, 8.79, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860883061349023744, 1, '2024-11-25 11:07:50', '2024-11-25 03:07:30', '2024-11-25 03:07:31', '2000-01-05 02:51:05', 2, 1, 0, '00:58:40', '00:01:20', 35.00, 35.00, 0.00, 0.00, 0.00, 2277.00, 8.73, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860883187173949440, 1, '2024-11-25 11:08:20', '2024-11-25 03:08:00', '2024-11-25 03:08:02', '2000-01-05 02:51:36', 2, 1, 0, '00:59:11', '00:00:49', 35.00, 35.00, 0.00, 0.00, 0.00, 2276.00, 8.70, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860883313007263744, 1, '2024-11-25 11:08:50', '2024-11-25 03:08:30', '2024-11-25 03:08:31', '2000-01-05 02:52:06', 2, 1, 0, '00:59:40', '00:00:20', 35.00, 35.00, 0.00, 0.00, 0.00, 2277.00, 8.62, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860883438827995136, 1, '2024-11-25 11:09:20', '2024-11-25 03:09:00', '2024-11-25 03:09:03', '2000-01-05 02:52:06', 2, 1, 0, '00:59:40', '00:00:20', 35.00, 35.00, 0.00, 0.00, 0.00, 2277.00, 8.62, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860883564665503744, 1, '2024-11-25 11:09:50', '2024-11-25 03:09:30', '2024-11-25 03:09:32', '2000-01-05 02:53:06', 2, 0, 0, '00:00:40', '22:59:20', 35.00, 35.00, 0.00, 0.00, 0.00, 2277.00, 8.59, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860883690494623744, 1, '2024-11-25 11:10:20', '2024-11-25 03:10:00', '2024-11-25 03:10:01', '2000-01-05 02:53:35', 2, 0, 0, '00:01:10', '22:58:50', 35.00, 35.00, 0.00, 0.00, 0.00, 2276.00, 8.55, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860883816319549440, 1, '2024-11-25 11:10:50', '2024-11-25 03:10:30', '2024-11-25 03:10:31', '2000-01-05 02:54:05', 2, 0, 0, '00:01:40', '22:58:20', 35.00, 35.00, 0.00, 0.00, 0.00, 2278.00, 8.54, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860883942140280832, 1, '2024-11-25 11:11:20', '2024-11-25 03:11:00', '2024-11-25 03:11:01', '2000-01-05 02:54:35', 2, 0, 0, '00:02:09', '22:57:51', 35.00, 35.00, 0.00, 0.00, 0.00, 2277.00, 8.55, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860884067973595136, 1, '2024-11-25 11:11:50', '2024-11-25 03:11:30', '2024-11-25 03:11:34', '2000-01-05 02:54:35', 2, 0, 0, '00:02:09', '22:57:51', 35.00, 35.00, 0.00, 0.00, 0.00, 2277.00, 8.55, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860884193798520832, 1, '2024-11-25 11:12:20', '2024-11-25 03:12:00', '2024-11-25 03:12:01', '2000-01-05 02:55:35', 2, 0, 0, '00:03:10', '22:56:50', 35.00, 35.00, 0.00, 0.00, 0.00, 2276.00, 8.52, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860884319640223744, 1, '2024-11-25 11:12:50', '2024-11-25 03:12:30', '2024-11-25 03:12:31', '2000-01-05 02:56:05', 2, 0, 0, '00:03:40', '22:56:20', 35.00, 35.00, 0.00, 0.00, 0.00, 2278.00, 8.50, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860884445460955136, 1, '2024-11-25 11:13:20', '2024-11-25 03:13:00', '2024-11-25 03:13:01', '2000-01-05 02:56:35', 2, 0, 0, '00:04:10', '22:55:50', 35.00, 35.00, 0.00, 0.00, 0.00, 2276.00, 8.49, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860884571281686528, 1, '2024-11-25 11:13:50', '2024-11-25 03:13:30', '2024-11-25 03:13:31', '2000-01-05 02:57:05', 2, 0, 0, '00:04:40', '22:55:20', 35.00, 35.00, 0.00, 0.00, 0.00, 2275.00, 8.49, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860884697106612224, 1, '2024-11-25 11:14:20', '2024-11-25 03:14:00', '2024-11-25 03:14:02', '2000-01-05 02:57:36', 2, 0, 0, '00:05:10', '22:54:50', 35.00, 35.00, 0.00, 0.00, 0.00, 2273.00, 8.55, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860884822948315136, 1, '2024-11-25 11:14:50', '2024-11-25 03:14:30', '2024-11-25 03:14:31', '2000-01-05 02:58:05', 2, 0, 0, '00:05:40', '22:54:20', 35.00, 35.00, 0.00, 0.00, 0.00, 2275.00, 8.54, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860884948769046528, 1, '2024-11-25 11:15:20', '2024-11-25 03:15:00', '2024-11-25 03:15:02', '2000-01-05 02:58:36', 2, 0, 0, '00:06:11', '22:53:49', 35.00, 35.00, 0.00, 0.00, 0.00, 2275.00, 8.56, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860885074606555136, 1, '2024-11-25 11:15:50', '2024-11-25 03:15:30', '2024-11-25 03:15:31', '2000-01-05 02:59:05', 2, 0, 0, '00:06:40', '22:53:20', 35.00, 35.00, 0.00, 0.00, 0.00, 2274.00, 8.56, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860885200435675136, 1, '2024-11-25 11:16:20', '2024-11-25 03:16:00', '2024-11-25 03:16:02', '2000-01-05 02:59:36', 2, 0, 0, '00:07:11', '22:52:49', 35.00, 35.00, 0.00, 0.00, 0.00, 2274.00, 8.62, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860885326260600832, 1, '2024-11-25 11:16:50', '2024-11-25 03:16:30', '2024-11-25 03:16:32', '2000-01-05 03:00:06', 2, 0, 0, '00:07:41', '22:52:19', 35.00, 35.00, 0.00, 0.00, 0.00, 2276.00, 8.64, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860885452093915136, 1, '2024-11-25 11:17:20', '2024-11-25 03:17:00', '2024-11-25 03:17:01', '2000-01-05 03:00:35', 2, 0, 0, '00:08:10', '22:51:50', 35.00, 35.00, 0.00, 0.00, 0.00, 2276.00, 8.61, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860886336123174912, 1, '2024-11-25 11:20:50', '2024-11-25 03:20:30', '2024-11-25 03:20:34', '2000-01-05 03:03:35', 2, 0, 0, '00:11:10', '22:48:50', 35.00, 35.00, 0.00, 0.00, 0.00, 2272.00, 8.69, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860886458756235264, 1, '2024-11-25 11:21:20', '2024-11-25 03:21:00', '2024-11-25 03:21:02', '2000-01-05 03:04:36', 2, 0, 0, '00:12:11', '22:47:49', 35.00, 35.00, 0.00, 0.00, 0.00, 2273.00, 8.74, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860886584576966656, 1, '2024-11-25 11:21:50', '2024-11-25 03:21:30', '2024-11-25 03:21:31', '2000-01-05 03:05:05', 2, 0, 0, '00:12:40', '22:47:20', 35.00, 35.00, 0.00, 0.00, 0.00, 2273.00, 8.75, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860886710401892352, 1, '2024-11-25 11:22:20', '2024-11-25 03:22:00', '2024-11-25 03:22:02', '2000-01-05 03:05:36', 2, 0, 0, '00:13:11', '22:46:49', 35.00, 35.00, 0.00, 0.00, 0.00, 2273.00, 8.83, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860886838302998528, 1, '2024-11-25 11:22:50', '2024-11-25 11:22:30', '2024-11-25 11:22:31', '2000-01-05 03:06:05', 2, 0, 0, '00:13:40', '22:46:20', 35.00, 35.00, 0.00, 0.00, 0.00, 2274.00, 8.89, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860886962081103872, 1, '2024-11-25 11:23:20', '2024-11-25 11:23:00', '2024-11-25 11:23:05', '2000-01-05 03:06:36', 2, 0, 0, '00:14:11', '22:45:49', 35.00, 35.00, 0.00, 0.00, 0.00, 2274.00, 8.89, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860887087906029568, 1, '2024-11-25 11:23:50', '2024-11-25 11:23:30', '2024-11-25 11:23:31', '2000-01-05 03:07:05', 2, 0, 0, '00:14:40', '22:45:20', 35.00, 35.00, 0.00, 0.00, 0.00, 2278.00, 8.89, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860887213714178048, 1, '2024-11-25 11:24:20', '2024-11-25 11:24:00', '2024-11-25 11:24:02', '2000-01-05 03:07:36', 2, 0, 0, '00:15:11', '22:44:49', 35.00, 35.00, 0.00, 0.00, 0.00, 2276.00, 8.90, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860887339547492352, 1, '2024-11-25 11:24:50', '2024-11-25 11:24:30', '2024-11-25 11:24:31', '2000-01-05 03:08:06', 2, 0, 0, '00:15:40', '22:44:20', 35.00, 35.00, 0.00, 0.00, 0.00, 2278.00, 8.88, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860887465401778176, 1, '2024-11-25 11:25:20', '2024-11-25 11:25:00', '2024-11-25 11:25:01', '2000-01-05 03:08:35', 2, 0, 0, '00:16:10', '22:43:50', 35.00, 35.00, 0.00, 0.00, 0.00, 2277.00, 8.96, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860887591205732352, 1, '2024-11-25 11:25:50', '2024-11-25 11:25:30', '2024-11-25 11:25:31', '2000-01-05 03:09:06', 2, 0, 0, '00:16:41', '22:43:19', 35.00, 35.00, 0.00, 0.00, 0.00, 2278.00, 8.97, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860887717034852352, 1, '2024-11-25 11:26:20', '2024-11-25 11:26:00', '2024-11-25 11:26:01', '2000-01-05 03:09:35', 2, 0, 0, '00:17:10', '22:42:50', 35.00, 35.00, 0.00, 0.00, 0.00, 2279.00, 8.95, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860887842859778048, 1, '2024-11-25 11:26:50', '2024-11-25 11:26:30', '2024-11-25 11:26:32', '2000-01-05 03:10:06', 2, 0, 0, '00:17:41', '22:42:19', 35.00, 35.00, 0.00, 0.00, 0.00, 2280.00, 8.94, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860887968688898048, 1, '2024-11-25 11:27:20', '2024-11-25 11:27:00', '2024-11-25 11:27:02', '2000-01-05 03:10:36', 2, 0, 0, '00:18:10', '22:41:50', 35.00, 35.00, 0.00, 0.00, 0.00, 2280.00, 8.96, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860888599868735488, 1, '2024-11-25 11:29:50', '2024-11-25 11:29:30', '2024-11-25 11:29:31', '2000-01-05 03:13:05', 2, 0, 0, '00:20:40', '22:39:20', 35.00, 35.00, 0.00, 0.00, 0.00, 2281.00, 8.92, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860888723688783872, 1, '2024-11-25 11:30:20', '2024-11-25 11:30:00', '2024-11-25 11:30:01', '2000-01-05 03:13:35', 2, 0, 0, '00:21:10', '22:38:50', 35.00, 35.00, 0.00, 0.00, 0.00, 2280.00, 8.91, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860888849501126656, 1, '2024-11-25 11:30:50', '2024-11-25 11:30:30', '2024-11-25 11:30:31', '2000-01-05 03:14:05', 2, 0, 0, '00:21:40', '22:38:20', 35.00, 35.00, 0.00, 0.00, 0.00, 2282.00, 8.92, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860888975313469440, 1, '2024-11-25 11:31:20', '2024-11-25 11:31:00', '2024-11-25 11:31:01', '2000-01-05 03:14:35', 2, 0, 0, '00:22:10', '22:37:50', 35.00, 35.00, 0.00, 0.00, 0.00, 2282.00, 8.90, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860889101142589440, 1, '2024-11-25 11:31:50', '2024-11-25 11:31:30', '2024-11-25 11:31:31', '2000-01-05 03:15:05', 2, 0, 0, '00:22:40', '22:37:20', 35.00, 35.00, 0.00, 0.00, 0.00, 2281.00, 8.85, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860889226975903744, 1, '2024-11-25 11:32:20', '2024-11-25 11:32:00', '2024-11-25 11:32:02', '2000-01-05 03:15:36', 2, 0, 0, '00:23:11', '22:36:49', 35.00, 35.00, 0.00, 0.00, 0.00, 2281.00, 8.84, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860889352805023744, 1, '2024-11-25 11:32:50', '2024-11-25 11:32:30', '2024-11-25 11:32:32', '2000-01-05 03:16:05', 2, 0, 0, '00:23:40', '22:36:20', 35.00, 35.00, 0.00, 0.00, 0.00, 2281.00, 8.78, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860889478638338048, 1, '2024-11-25 11:33:20', '2024-11-25 11:33:00', '2024-11-25 11:33:01', '2000-01-05 03:16:35', 2, 0, 0, '00:24:10', '22:35:50', 35.00, 35.00, 0.00, 0.00, 0.00, 2283.00, 8.76, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860889604467458048, 1, '2024-11-25 11:33:50', '2024-11-25 11:33:30', '2024-11-25 11:33:31', '2000-01-05 03:17:06', 2, 0, 0, '00:24:41', '22:35:19', 35.00, 35.00, 0.00, 0.00, 0.00, 2282.00, 8.77, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860889730292383744, 1, '2024-11-25 11:34:20', '2024-11-25 11:34:00', '2024-11-25 11:34:01', '2000-01-05 03:17:35', 2, 0, 0, '00:25:10', '22:34:50', 35.00, 35.00, 0.00, 0.00, 0.00, 2282.00, 8.78, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860889856121503744, 1, '2024-11-25 11:34:50', '2024-11-25 11:34:30', '2024-11-25 11:34:32', '2000-01-05 03:18:06', 2, 0, 0, '00:25:41', '22:34:19', 35.00, 35.00, 0.00, 0.00, 0.00, 2282.00, 8.78, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860889981946429440, 1, '2024-11-25 11:35:20', '2024-11-25 11:35:00', '2024-11-25 11:35:02', '2000-01-05 03:18:35', 2, 0, 0, '00:26:10', '22:33:50', 35.00, 35.00, 0.00, 0.00, 0.00, 2283.00, 8.79, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860890107771355136, 1, '2024-11-25 11:35:50', '2024-11-25 11:35:30', '2024-11-25 11:35:32', '2000-01-05 03:19:06', 2, 0, 0, '00:26:41', '22:33:19', 35.00, 35.00, 0.00, 0.00, 0.00, 2286.00, 8.73, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860890233608863744, 1, '2024-11-25 11:36:20', '2024-11-25 11:36:00', '2024-11-25 11:36:02', '2000-01-05 03:19:35', 2, 0, 0, '00:27:10', '22:32:50', 35.00, 35.00, 0.00, 0.00, 0.00, 2285.00, 8.71, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860890359442178048, 1, '2024-11-25 11:36:50', '2024-11-25 11:36:30', '2024-11-25 11:36:32', '2000-01-05 03:20:06', 2, 0, 0, '00:27:41', '22:32:19', 35.00, 35.00, 0.00, 0.00, 0.00, 2286.00, 8.62, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860890485271298048, 1, '2024-11-25 11:37:20', '2024-11-25 11:37:00', '2024-11-25 11:37:02', '2000-01-05 03:20:36', 2, 0, 0, '00:28:10', '22:31:50', 35.00, 35.00, 0.00, 0.00, 0.00, 2287.00, 8.62, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860890611100418048, 1, '2024-11-25 11:37:50', '2024-11-25 11:37:30', '2024-11-25 11:37:31', '2000-01-05 03:21:05', 2, 0, 0, '00:28:40', '22:31:20', 35.00, 35.00, 0.00, 0.00, 0.00, 2290.00, 8.62, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860890736925343744, 1, '2024-11-25 11:38:20', '2024-11-25 11:38:00', '2024-11-25 11:38:02', '2000-01-05 03:21:36', 2, 0, 0, '00:29:11', '22:30:49', 35.00, 35.00, 0.00, 0.00, 0.00, 2289.00, 8.68, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860890862754463744, 1, '2024-11-25 11:38:50', '2024-11-25 11:38:30', '2024-11-25 11:38:31', '2000-01-05 03:22:05', 2, 0, 0, '00:29:40', '22:30:20', 35.00, 35.00, 0.00, 0.00, 0.00, 2289.00, 8.69, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860890988575195136, 1, '2024-11-25 11:39:20', '2024-11-25 11:39:00', '2024-11-25 11:39:04', '2000-01-05 03:22:05', 2, 0, 0, '00:29:40', '22:30:20', 35.00, 35.00, 0.00, 0.00, 0.00, 2289.00, 8.69, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860891114404315136, 1, '2024-11-25 11:39:50', '2024-11-25 11:39:30', '2024-11-25 11:39:31', '2000-01-05 03:23:05', 2, 0, 0, '00:30:40', '22:29:20', 35.00, 35.00, 0.00, 0.00, 0.00, 2288.00, 8.74, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860891240237629440, 1, '2024-11-25 11:40:20', '2024-11-25 11:40:00', '2024-11-25 11:40:01', '2000-01-05 03:23:35', 2, 0, 0, '00:31:10', '22:28:50', 35.00, 35.00, 0.00, 0.00, 0.00, 2288.00, 8.72, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860891366070943744, 1, '2024-11-25 11:40:50', '2024-11-25 11:40:30', '2024-11-25 11:40:31', '2000-01-05 03:24:05', 2, 0, 0, '00:31:40', '22:28:20', 35.00, 35.00, 0.00, 0.00, 0.00, 2288.00, 8.71, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860891491887480832, 1, '2024-11-25 11:41:20', '2024-11-25 11:41:00', '2024-11-25 11:41:01', '2000-01-05 03:24:35', 2, 0, 0, '00:32:10', '22:27:50', 35.00, 35.00, 0.00, 0.00, 0.00, 2288.00, 8.69, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860891869379035136, 1, '2024-11-25 11:42:50', '2024-11-25 11:42:30', '2024-11-25 11:42:32', '2000-01-05 03:26:06', 2, 0, 0, '00:33:41', '22:26:19', 35.00, 35.00, 0.00, 0.00, 0.00, 2289.00, 8.73, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860891995208155136, 1, '2024-11-25 11:43:20', '2024-11-25 11:43:00', '2024-11-25 11:43:01', '2000-01-05 03:26:35', 2, 0, 0, '00:34:10', '22:25:50', 35.00, 35.00, 0.00, 0.00, 0.00, 2289.00, 8.73, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860892121037275136, 1, '2024-11-25 11:43:50', '2024-11-25 11:43:30', '2024-11-25 11:43:32', '2000-01-05 03:27:06', 2, 0, 0, '00:34:41', '22:25:19', 35.00, 35.00, 0.00, 0.00, 0.00, 2292.00, 8.75, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860892246866395136, 1, '2024-11-25 11:44:20', '2024-11-25 11:44:00', '2024-11-25 11:44:02', '2000-01-05 03:27:36', 2, 0, 0, '00:35:11', '22:24:49', 35.00, 35.00, 0.00, 0.00, 0.00, 2291.00, 8.72, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860892498520440832, 1, '2024-11-25 11:45:20', '2024-11-25 11:45:00', '2024-11-25 11:45:04', '2000-01-05 03:27:36', 2, 0, 0, '00:35:11', '22:24:49', 35.00, 35.00, 0.00, 0.00, 0.00, 2291.00, 8.72, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860892624345366528, 1, '2024-11-25 11:45:50', '2024-11-25 11:45:30', '2024-11-25 11:45:31', '2000-01-05 03:29:05', 2, 0, 0, '00:36:40', '22:23:20', 35.00, 35.00, 0.00, 0.00, 0.00, 2293.00, 8.64, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860892750178680832, 1, '2024-11-25 11:46:20', '2024-11-25 11:46:00', '2024-11-25 11:46:04', '2000-01-05 03:29:05', 2, 0, 0, '00:36:40', '22:23:20', 35.00, 35.00, 0.00, 0.00, 0.00, 2293.00, 8.64, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860892876007800832, 1, '2024-11-25 11:46:50', '2024-11-25 11:46:30', '2024-11-25 11:46:31', '2000-01-05 03:30:05', 2, 0, 0, '00:37:40', '22:22:20', 35.00, 35.00, 0.00, 0.00, 0.00, 2296.00, 8.55, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860893001841115136, 1, '2024-11-25 11:47:20', '2024-11-25 11:47:00', '2024-11-25 11:47:02', '2000-01-05 03:30:36', 2, 0, 0, '00:38:11', '22:21:49', 35.00, 35.00, 0.00, 0.00, 0.00, 2295.00, 8.50, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860893127670235136, 1, '2024-11-25 11:47:50', '2024-11-25 11:47:30', '2024-11-25 11:47:32', '2000-01-05 03:31:06', 2, 0, 0, '00:38:40', '22:21:20', 35.00, 35.00, 0.00, 0.00, 0.00, 2297.00, 8.49, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860893253495160832, 1, '2024-11-25 11:48:20', '2024-11-25 11:48:00', '2024-11-25 11:48:01', '2000-01-05 03:31:35', 2, 0, 0, '00:39:10', '22:20:50', 35.00, 35.00, 0.00, 0.00, 0.00, 2297.00, 8.45, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860893379324280832, 1, '2024-11-25 11:48:50', '2024-11-25 11:48:30', '2024-11-25 11:48:31', '2000-01-05 03:32:05', 2, 0, 0, '00:39:40', '22:20:20', 35.00, 35.00, 0.00, 0.00, 0.00, 2297.00, 8.47, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860893505153400832, 1, '2024-11-25 11:49:20', '2024-11-25 11:49:00', '2024-11-25 11:49:01', '2000-01-05 03:32:35', 2, 0, 0, '00:40:10', '22:19:50', 35.00, 35.00, 0.00, 0.00, 0.00, 2297.00, 8.48, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860893630982520832, 1, '2024-11-25 11:49:50', '2024-11-25 11:49:30', '2024-11-25 11:49:31', '2000-01-05 03:33:05', 2, 0, 0, '00:40:40', '22:19:20', 35.00, 35.00, 0.00, 0.00, 0.00, 2295.00, 8.46, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860893756807446528, 1, '2024-11-25 11:50:20', '2024-11-25 11:50:00', '2024-11-25 11:50:01', '2000-01-05 03:33:35', 2, 0, 0, '00:41:09', '22:18:51', 35.00, 35.00, 0.00, 0.00, 0.00, 2298.00, 8.52, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860893882644955136, 1, '2024-11-25 11:50:50', '2024-11-25 11:50:30', '2024-11-25 11:50:31', '2000-01-05 03:34:05', 2, 0, 0, '00:41:40', '22:18:20', 35.00, 35.00, 0.00, 0.00, 0.00, 2299.00, 8.53, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860894008474075136, 1, '2024-11-25 11:51:20', '2024-11-25 11:51:00', '2024-11-25 11:51:01', '2000-01-05 03:34:35', 2, 0, 0, '00:42:10', '22:17:50', 35.00, 35.00, 0.00, 0.00, 0.00, 2298.00, 8.49, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860894134294806528, 1, '2024-11-25 11:51:50', '2024-11-25 11:51:30', '2024-11-25 11:51:34', '2000-01-05 03:34:35', 2, 0, 0, '00:42:10', '22:17:50', 35.00, 35.00, 0.00, 0.00, 0.00, 2298.00, 8.49, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860894260123926528, 1, '2024-11-25 11:52:20', '2024-11-25 11:52:00', '2024-11-25 11:52:02', '2000-01-05 03:35:36', 2, 0, 0, '00:43:11', '22:16:49', 35.00, 35.00, 0.00, 0.00, 0.00, 2299.00, 8.51, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860894385953046528, 1, '2024-11-25 11:52:50', '2024-11-25 11:52:30', '2024-11-25 11:52:32', '2000-01-05 03:36:06', 2, 0, 0, '00:43:41', '22:16:19', 35.00, 35.00, 0.00, 0.00, 0.00, 2299.00, 8.45, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860894511786360832, 1, '2024-11-25 11:53:20', '2024-11-25 11:53:00', '2024-11-25 11:53:02', '2000-01-05 03:36:35', 2, 0, 0, '00:44:10', '22:15:50', 35.00, 35.00, 0.00, 0.00, 0.00, 2299.00, 8.43, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860894637611286528, 1, '2024-11-25 11:53:50', '2024-11-25 11:53:30', '2024-11-25 11:53:31', '2000-01-05 03:37:05', 2, 0, 0, '00:44:40', '22:15:20', 35.00, 35.00, 0.00, 0.00, 0.00, 2298.00, 8.39, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860894763444600832, 1, '2024-11-25 11:54:20', '2024-11-25 11:54:00', '2024-11-25 11:54:02', '2000-01-05 03:37:36', 2, 0, 0, '00:45:11', '22:14:49', 35.00, 35.00, 0.00, 0.00, 0.00, 2301.00, 8.35, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860894889269526528, 1, '2024-11-25 11:54:50', '2024-11-25 11:54:30', '2024-11-25 11:54:31', '2000-01-05 03:38:05', 2, 0, 0, '00:45:40', '22:14:20', 35.00, 35.00, 0.00, 0.00, 0.00, 2301.00, 8.40, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860895266752692224, 1, '2024-11-25 11:56:20', '2024-11-25 11:56:00', '2024-11-25 11:56:02', '2000-01-05 03:39:36', 2, 0, 0, '00:47:11', '22:12:49', 35.00, 35.00, 0.00, 0.00, 0.00, 2303.00, 8.37, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860895392586006528, 1, '2024-11-25 11:56:50', '2024-11-25 11:56:30', '2024-11-25 11:56:32', '2000-01-05 03:40:06', 2, 0, 0, '00:47:41', '22:12:19', 35.00, 35.00, 0.00, 0.00, 0.00, 2302.00, 8.41, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860895518423515136, 1, '2024-11-25 11:57:20', '2024-11-25 11:57:00', '2024-11-25 11:57:04', '2000-01-05 03:40:06', 2, 0, 0, '00:47:41', '22:12:19', 35.00, 35.00, 0.00, 0.00, 0.00, 2302.00, 8.41, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860895644244246528, 1, '2024-11-25 11:57:50', '2024-11-25 11:57:30', '2024-11-25 11:57:31', '2000-01-05 03:41:05', 2, 0, 0, '00:48:39', '22:11:21', 35.00, 35.00, 0.00, 0.00, 0.00, 2305.00, 8.40, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860895770077560832, 1, '2024-11-25 11:58:20', '2024-11-25 11:58:00', '2024-11-25 11:58:01', '2000-01-05 03:41:35', 2, 0, 0, '00:49:10', '22:10:50', 35.00, 35.00, 0.00, 0.00, 0.00, 2304.00, 8.44, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860895895898292224, 1, '2024-11-25 11:58:50', '2024-11-25 11:58:30', '2024-11-25 11:58:31', '2000-01-05 03:42:05', 2, 0, 0, '00:49:40', '22:10:20', 35.00, 35.00, 0.00, 0.00, 0.00, 2305.00, 8.49, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860896021727412224, 1, '2024-11-25 11:59:20', '2024-11-25 11:59:00', '2024-11-25 11:59:01', '2000-01-05 03:42:35', 2, 0, 0, '00:50:10', '22:09:50', 35.00, 35.00, 0.00, 0.00, 0.00, 2304.00, 8.64, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860896147556532224, 1, '2024-11-25 11:59:50', '2024-11-25 11:59:30', '2024-11-25 11:59:32', '2000-01-05 03:43:06', 2, 0, 0, '00:50:41', '22:09:19', 35.00, 35.00, 0.00, 0.00, 0.00, 2303.00, 8.67, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860896273389846528, 1, '2024-11-25 12:00:20', '2024-11-25 12:00:00', '2024-11-25 12:00:02', '2000-01-05 03:43:36', 2, 0, 0, '00:51:10', '22:08:50', 35.00, 35.00, 0.00, 0.00, 0.00, 2304.00, 8.65, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860896399218966528, 1, '2024-11-25 12:00:50', '2024-11-25 12:00:30', '2024-11-25 12:00:35', '2000-01-05 03:44:06', 2, 0, 0, '00:51:41', '22:08:19', 35.00, 35.00, 0.00, 0.00, 0.00, 2303.00, 8.59, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860896525052280832, 1, '2024-11-25 12:01:20', '2024-11-25 12:01:00', '2024-11-25 12:01:02', '2000-01-05 03:44:36', 2, 0, 0, '00:52:11', '22:07:49', 35.00, 35.00, 0.00, 0.00, 0.00, 2303.00, 8.56, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860896650877206528, 1, '2024-11-25 12:01:50', '2024-11-25 12:01:30', '2024-11-25 12:01:31', '2000-01-05 03:45:05', 2, 0, 0, '00:52:40', '22:07:20', 35.00, 35.00, 0.00, 0.00, 0.00, 2305.00, 8.55, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860896776702132224, 1, '2024-11-25 12:02:20', '2024-11-25 12:02:00', '2024-11-25 12:02:04', '2000-01-05 03:45:05', 2, 0, 0, '00:52:40', '22:07:20', 35.00, 35.00, 0.00, 0.00, 0.00, 2305.00, 8.55, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860896902535446528, 1, '2024-11-25 12:02:50', '2024-11-25 12:02:30', '2024-11-25 12:02:34', '2000-01-05 03:45:05', 2, 0, 0, '00:52:40', '22:07:20', 35.00, 35.00, 0.00, 0.00, 0.00, 2305.00, 8.55, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860897028364566528, 1, '2024-11-25 12:03:20', '2024-11-25 12:03:00', '2024-11-25 12:03:02', '2000-01-05 03:46:36', 2, 0, 0, '00:54:11', '22:05:49', 35.00, 35.00, 0.00, 0.00, 0.00, 2306.00, 8.52, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860897154197880832, 1, '2024-11-25 12:03:50', '2024-11-25 12:03:30', '2024-11-25 12:03:32', '2000-01-05 03:47:05', 2, 0, 0, '00:54:40', '22:05:20', 35.00, 35.00, 0.00, 0.00, 0.00, 2308.00, 8.47, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860897280022806528, 1, '2024-11-25 12:04:20', '2024-11-25 12:04:00', '2024-11-25 12:04:02', '2000-01-05 03:47:36', 2, 0, 0, '00:55:11', '22:04:49', 35.00, 35.00, 0.00, 0.00, 0.00, 2308.00, 8.46, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860897405851926528, 1, '2024-11-25 12:04:50', '2024-11-25 12:04:30', '2024-11-25 12:04:32', '2000-01-05 03:48:06', 2, 0, 0, '00:55:40', '22:04:20', 35.00, 35.00, 0.00, 0.00, 0.00, 2309.00, 8.50, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860897531676852224, 1, '2024-11-25 12:05:20', '2024-11-25 12:05:00', '2024-11-25 12:05:01', '2000-01-05 03:48:35', 2, 0, 0, '00:56:10', '22:03:50', 35.00, 35.00, 0.00, 0.00, 0.00, 2310.00, 8.45, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860897657501777920, 1, '2024-11-25 12:05:50', '2024-11-25 12:05:30', '2024-11-25 12:05:32', '2000-01-05 03:49:06', 2, 0, 0, '00:56:41', '22:03:19', 35.00, 35.00, 0.00, 0.00, 0.00, 2311.00, 8.46, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860897783343480832, 1, '2024-11-25 12:06:20', '2024-11-25 12:06:00', '2024-11-25 12:06:01', '2000-01-05 03:49:35', 2, 0, 0, '00:57:10', '22:02:50', 35.00, 35.00, 0.00, 0.00, 0.00, 2311.00, 8.44, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860897909164212224, 1, '2024-11-25 12:06:50', '2024-11-25 12:06:30', '2024-11-25 12:06:31', '2000-01-05 03:50:05', 2, 0, 0, '00:57:40', '22:02:20', 35.00, 35.00, 0.00, 0.00, 0.00, 2312.00, 8.43, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860898160830840832, 1, '2024-11-25 12:07:50', '2024-11-25 12:07:30', '2024-11-25 12:07:34', '2000-01-05 03:50:05', 2, 0, 0, '00:57:40', '22:02:20', 35.00, 35.00, 0.00, 0.00, 0.00, 2312.00, 8.43, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860898286659960832, 1, '2024-11-25 12:08:20', '2024-11-25 12:08:00', '2024-11-25 12:08:02', '2000-01-05 03:51:35', 2, 0, 0, '00:59:10', '22:00:50', 35.00, 35.00, 0.00, 0.00, 0.00, 2312.00, 8.47, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860898412489080832, 1, '2024-11-25 12:08:50', '2024-11-25 12:08:30', '2024-11-25 12:08:32', '2000-01-05 03:52:06', 2, 0, 0, '00:59:41', '22:00:19', 35.00, 35.00, 0.00, 0.00, 0.00, 2312.00, 8.47, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860898538314006528, 1, '2024-11-25 12:09:20', '2024-11-25 12:09:00', '2024-11-25 12:09:02', '2000-01-05 03:52:36', 2, 0, 0, '01:00:11', '21:59:49', 35.00, 35.00, 0.00, 0.00, 0.00, 2312.00, 8.50, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860898664143126528, 1, '2024-11-25 12:09:50', '2024-11-25 12:09:30', '2024-11-25 12:09:31', '2000-01-05 03:53:05', 2, 0, 0, '01:00:40', '21:59:20', 35.00, 35.00, 0.00, 0.00, 0.00, 2314.00, 8.45, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860898789976440832, 1, '2024-11-25 12:10:20', '2024-11-25 12:10:00', '2024-11-25 12:10:02', '2000-01-05 03:53:36', 2, 0, 0, '01:01:10', '21:58:50', 35.00, 35.00, 0.00, 0.00, 0.00, 2315.00, 8.42, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860898915797172224, 1, '2024-11-25 12:10:50', '2024-11-25 12:10:30', '2024-11-25 12:10:31', '2000-01-05 03:54:05', 2, 0, 0, '01:01:40', '21:58:20', 35.00, 35.00, 0.00, 0.00, 0.00, 2314.00, 8.40, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860899041634680832, 1, '2024-11-25 12:11:20', '2024-11-25 12:11:00', '2024-11-25 12:11:02', '2000-01-05 03:54:36', 2, 0, 0, '01:02:11', '21:57:49', 35.00, 35.00, 0.00, 0.00, 0.00, 2316.00, 8.31, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860899167455412224, 1, '2024-11-25 12:11:50', '2024-11-25 12:11:30', '2024-11-25 12:11:31', '2000-01-05 03:55:05', 2, 0, 0, '01:02:40', '21:57:20', 35.00, 35.00, 0.00, 0.00, 0.00, 2316.00, 8.26, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860899293288726528, 1, '2024-11-25 12:12:20', '2024-11-25 12:12:00', '2024-11-25 12:12:02', '2000-01-05 03:55:36', 2, 0, 0, '01:03:11', '21:56:49', 35.00, 35.00, 0.00, 0.00, 0.00, 2316.00, 8.21, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860899419113652224, 1, '2024-11-25 12:12:50', '2024-11-25 12:12:30', '2024-11-25 12:12:32', '2000-01-05 03:56:06', 2, 0, 0, '01:03:41', '21:56:19', 35.00, 35.00, 0.00, 0.00, 0.00, 2318.00, 8.16, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860899544938577920, 1, '2024-11-25 12:13:20', '2024-11-25 12:13:00', '2024-11-25 12:13:01', '2000-01-05 03:56:35', 2, 0, 0, '01:04:10', '21:55:50', 35.00, 35.00, 0.00, 0.00, 0.00, 2319.00, 8.17, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860899670771892224, 1, '2024-11-25 12:13:50', '2024-11-25 12:13:30', '2024-11-25 12:13:32', '2000-01-05 03:57:06', 2, 0, 0, '01:04:41', '21:55:19', 35.00, 35.00, 0.00, 0.00, 0.00, 2318.00, 8.24, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860899796601012224, 1, '2024-11-25 12:14:20', '2024-11-25 12:14:00', '2024-11-25 12:14:00', '2000-01-05 03:57:35', 2, 0, 0, '01:05:10', '21:54:50', 35.00, 35.00, 0.00, 0.00, 0.00, 2319.00, 8.24, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860899922434326528, 1, '2024-11-25 12:14:50', '2024-11-25 12:14:30', '2024-11-25 12:14:31', '2000-01-05 03:58:05', 2, 0, 0, '01:05:40', '21:54:20', 35.00, 35.00, 0.00, 0.00, 0.00, 2317.00, 8.26, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860900048259252224, 1, '2024-11-25 12:15:20', '2024-11-25 12:15:00', '2024-11-25 12:15:01', '2000-01-05 03:58:35', 2, 0, 0, '01:06:10', '21:53:50', 35.00, 35.00, 0.00, 0.00, 0.00, 2317.00, 8.25, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860900174088372224, 1, '2024-11-25 12:15:50', '2024-11-25 12:15:30', '2024-11-25 12:15:31', '2000-01-05 03:59:05', 2, 0, 0, '01:06:40', '21:53:20', 35.00, 35.00, 0.00, 0.00, 0.00, 2319.00, 8.28, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860900299917492224, 1, '2024-11-25 12:16:20', '2024-11-25 12:16:00', '2024-11-25 12:16:01', '2000-01-05 03:59:35', 2, 0, 0, '01:07:10', '21:52:50', 35.00, 35.00, 0.00, 0.00, 0.00, 2318.00, 8.30, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860900425742417920, 1, '2024-11-25 12:16:50', '2024-11-25 12:16:30', '2024-11-25 12:16:31', '2000-01-05 04:00:05', 2, 0, 0, '01:07:40', '21:52:20', 35.00, 35.00, 0.00, 0.00, 0.00, 2319.00, 8.31, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860900551571537920, 1, '2024-11-25 12:17:20', '2024-11-25 12:17:00', '2024-11-25 12:17:02', '2000-01-05 04:00:36', 2, 0, 0, '01:08:11', '21:51:49', 35.00, 35.00, 0.00, 0.00, 0.00, 2316.00, 8.36, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860900677404852224, 1, '2024-11-25 12:17:50', '2024-11-25 12:17:30', '2024-11-25 12:17:34', '2000-01-05 04:00:36', 2, 0, 0, '01:08:11', '21:51:49', 35.00, 35.00, 0.00, 0.00, 0.00, 2316.00, 8.36, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860900803242360832, 1, '2024-11-25 12:18:20', '2024-11-25 12:18:00', '2024-11-25 12:18:02', '2000-01-05 04:01:36', 2, 0, 0, '01:09:11', '21:50:49', 35.00, 35.00, 0.00, 0.00, 0.00, 2317.00, 8.34, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860900929063092224, 1, '2024-11-25 12:18:50', '2024-11-25 12:18:30', '2024-11-25 12:18:31', '2000-01-05 04:02:05', 2, 0, 0, '01:09:40', '21:50:20', 35.00, 35.00, 0.00, 0.00, 0.00, 2319.00, 8.37, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860901054892212224, 1, '2024-11-25 12:19:20', '2024-11-25 12:19:00', '2024-11-25 12:19:02', '2000-01-05 04:02:36', 2, 0, 0, '01:10:11', '21:49:49', 35.00, 35.00, 0.00, 0.00, 0.00, 2319.00, 8.35, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860901180759080960, 1, '2024-11-25 12:19:50', '2024-11-25 12:19:30', '2024-11-25 12:19:32', '2000-01-05 04:03:06', 2, 0, 0, '01:10:41', '21:49:19', 35.00, 35.00, 0.00, 0.00, 0.00, 2320.00, 8.32, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860901432383766528, 1, '2024-11-25 12:20:50', '2024-11-25 12:20:30', '2024-11-25 12:20:32', '2000-01-05 04:04:06', 2, 0, 0, '01:11:40', '21:48:20', 35.00, 35.00, 0.00, 0.00, 0.00, 2320.00, 8.16, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860901558208692224, 1, '2024-11-25 12:21:20', '2024-11-25 12:21:00', '2024-11-25 12:21:04', '2000-01-05 04:04:35', 2, 0, 0, '01:12:10', '21:47:50', 35.00, 35.00, 0.00, 0.00, 0.00, 2322.00, 8.09, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860901684037812224, 1, '2024-11-25 12:21:50', '2024-11-25 12:21:30', '2024-11-25 12:21:32', '2000-01-05 04:05:06', 2, 0, 0, '01:12:41', '21:47:19', 35.00, 35.00, 0.00, 0.00, 0.00, 2323.00, 8.13, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860901935696052224, 1, '2024-11-25 12:22:50', '2024-11-25 12:22:30', '2024-11-25 12:22:33', '2000-01-05 04:05:06', 2, 0, 0, '01:12:41', '21:47:19', 35.00, 35.00, 0.00, 0.00, 0.00, 2323.00, 8.13, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860902061516783616, 1, '2024-11-25 12:23:20', '2024-11-25 12:23:00', '2024-11-25 12:23:00', '2000-01-05 04:06:35', 2, 0, 0, '01:14:10', '21:45:50', 35.00, 35.00, 0.00, 0.00, 0.00, 2322.00, 8.02, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860902439012532224, 1, '2024-11-25 12:24:50', '2024-11-25 12:24:30', '2024-11-25 12:24:31', '2000-01-05 04:08:05', 2, 0, 0, '01:15:40', '21:44:20', 35.00, 35.00, 0.00, 0.00, 0.00, 2321.00, 8.07, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860902564858429440, 1, '2024-11-25 12:25:20', '2024-11-25 12:25:00', '2024-11-25 12:25:01', '2000-01-05 04:08:35', 2, 0, 0, '01:16:10', '21:43:50', 35.00, 35.00, 0.00, 0.00, 0.00, 2321.00, 8.03, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860902690670772224, 1, '2024-11-25 12:25:50', '2024-11-25 12:25:30', '2024-11-25 12:25:31', '2000-01-05 04:09:05', 2, 0, 0, '01:16:40', '21:43:20', 35.00, 35.00, 0.00, 0.00, 0.00, 2323.00, 8.10, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860902816495697920, 1, '2024-11-25 12:26:20', '2024-11-25 12:26:00', '2024-11-25 12:26:01', '2000-01-05 04:09:35', 2, 0, 0, '01:17:10', '21:42:50', 35.00, 35.00, 0.00, 0.00, 0.00, 2325.00, 8.11, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860902942320623616, 1, '2024-11-25 12:26:50', '2024-11-25 12:26:30', '2024-11-25 12:26:31', '2000-01-05 04:10:05', 2, 0, 0, '01:17:40', '21:42:20', 35.00, 35.00, 0.00, 0.00, 0.00, 2327.00, 8.08, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860903068162326528, 1, '2024-11-25 12:27:20', '2024-11-25 12:27:00', '2024-11-25 12:27:01', '2000-01-05 04:10:35', 2, 0, 0, '01:18:10', '21:41:50', 35.00, 35.00, 0.00, 0.00, 0.00, 2324.00, 8.00, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860903193983057920, 1, '2024-11-25 12:27:50', '2024-11-25 12:27:30', '2024-11-25 12:27:31', '2000-01-05 04:11:05', 2, 0, 0, '01:18:40', '21:41:20', 35.00, 35.00, 0.00, 0.00, 0.00, 2324.00, 8.02, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860903319816372224, 1, '2024-11-25 12:28:20', '2024-11-25 12:28:00', '2024-11-25 12:28:05', '2000-01-05 04:11:36', 2, 0, 0, '01:19:11', '21:40:49', 35.00, 35.00, 0.00, 0.00, 0.00, 2323.00, 8.00, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860903445649686528, 1, '2024-11-25 12:28:50', '2024-11-25 12:28:30', '2024-11-25 12:28:32', '2000-01-05 04:12:05', 2, 0, 0, '01:19:40', '21:40:20', 35.00, 35.00, 0.00, 0.00, 0.00, 2323.00, 8.04, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860903571470417920, 1, '2024-11-25 12:29:20', '2024-11-25 12:29:00', '2024-11-25 12:29:01', '2000-01-05 04:12:35', 2, 0, 0, '01:20:10', '21:39:50', 35.00, 35.00, 0.00, 0.00, 0.00, 2324.00, 8.02, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860903697299537920, 1, '2024-11-25 12:29:50', '2024-11-25 12:29:30', '2024-11-25 12:29:32', '2000-01-05 04:13:06', 2, 0, 0, '01:20:41', '21:39:19', 35.00, 35.00, 0.00, 0.00, 0.00, 2326.00, 8.06, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860903823137046528, 1, '2024-11-25 12:30:20', '2024-11-25 12:30:00', '2024-11-25 12:30:01', '2000-01-05 04:13:35', 2, 0, 0, '01:21:10', '21:38:50', 35.00, 35.00, 0.00, 0.00, 0.00, 2325.00, 7.95, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860903948961972224, 1, '2024-11-25 12:30:50', '2024-11-25 12:30:30', '2024-11-25 12:30:32', '2000-01-05 04:14:06', 2, 0, 0, '01:21:41', '21:38:19', 35.00, 35.00, 0.00, 0.00, 0.00, 2325.00, 7.93, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860904074786897920, 1, '2024-11-25 12:31:20', '2024-11-25 12:31:00', '2024-11-25 12:31:01', '2000-01-05 04:14:35', 2, 0, 0, '01:22:10', '21:37:50', 35.00, 35.00, 0.00, 0.00, 0.00, 2324.00, 7.89, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860904200624406528, 1, '2024-11-25 12:31:50', '2024-11-25 12:31:30', '2024-11-25 12:31:32', '2000-01-05 04:15:06', 2, 0, 0, '01:22:41', '21:37:19', 35.00, 35.00, 0.00, 0.00, 0.00, 2326.00, 7.86, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860904326449332224, 1, '2024-11-25 12:32:20', '2024-11-25 12:32:00', '2024-11-25 12:32:02', '2000-01-05 04:15:36', 2, 0, 0, '01:23:11', '21:36:49', 35.00, 35.00, 0.00, 0.00, 0.00, 2326.00, 7.88, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860904452274257920, 1, '2024-11-25 12:32:50', '2024-11-25 12:32:30', '2024-11-25 12:32:32', '2000-01-05 04:16:06', 2, 0, 0, '01:23:41', '21:36:19', 35.00, 35.00, 0.00, 0.00, 0.00, 2324.00, 7.90, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860904578124349440, 1, '2024-11-25 12:33:20', '2024-11-25 12:33:00', '2024-11-25 12:33:02', '2000-01-05 04:16:36', 2, 0, 0, '01:24:10', '21:35:50', 35.00, 35.00, 0.00, 0.00, 0.00, 2325.00, 7.90, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860904703940886528, 1, '2024-11-25 12:33:50', '2024-11-25 12:33:30', '2024-11-25 12:33:34', '2000-01-05 04:17:05', 2, 0, 0, '01:24:40', '21:35:20', 35.00, 35.00, 0.00, 0.00, 0.00, 2325.00, 7.89, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860904829757423616, 1, '2024-11-25 12:34:20', '2024-11-25 12:34:00', '2024-11-25 12:34:02', '2000-01-05 04:17:36', 2, 0, 0, '01:25:11', '21:34:49', 35.00, 35.00, 0.00, 0.00, 0.00, 2325.00, 7.93, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860904955586543616, 1, '2024-11-25 12:34:50', '2024-11-25 12:34:30', '2024-11-25 12:34:31', '2000-01-05 04:18:05', 2, 0, 0, '01:25:40', '21:34:20', 35.00, 35.00, 0.00, 0.00, 0.00, 2327.00, 7.99, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860905081419857920, 1, '2024-11-25 12:35:20', '2024-11-25 12:35:00', '2024-11-25 12:35:02', '2000-01-05 04:18:36', 2, 0, 0, '01:26:11', '21:33:49', 35.00, 35.00, 0.00, 0.00, 0.00, 2326.00, 8.02, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860905207253172224, 1, '2024-11-25 12:35:50', '2024-11-25 12:35:30', '2024-11-25 12:35:31', '2000-01-05 04:19:05', 2, 0, 0, '01:26:40', '21:33:20', 35.00, 35.00, 0.00, 0.00, 0.00, 2327.00, 8.09, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860905333082292224, 1, '2024-11-25 12:36:20', '2024-11-25 12:36:00', '2024-11-25 12:36:01', '2000-01-05 04:19:35', 2, 0, 0, '01:27:10', '21:32:50', 35.00, 35.00, 0.00, 0.00, 0.00, 2327.00, 8.15, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860905458903023616, 1, '2024-11-25 12:36:50', '2024-11-25 12:36:30', '2024-11-25 12:36:31', '2000-01-05 04:20:05', 2, 0, 0, '01:27:40', '21:32:20', 35.00, 35.00, 0.00, 0.00, 0.00, 2328.00, 8.20, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860905584736337920, 1, '2024-11-25 12:37:20', '2024-11-25 12:37:00', '2024-11-25 12:37:01', '2000-01-05 04:20:35', 2, 0, 0, '01:28:10', '21:31:50', 35.00, 35.00, 0.00, 0.00, 0.00, 2328.00, 8.20, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860905710561263616, 1, '2024-11-25 12:37:50', '2024-11-25 12:37:30', '2024-11-25 12:37:31', '2000-01-05 04:21:05', 2, 0, 0, '01:28:40', '21:31:20', 35.00, 35.00, 0.00, 0.00, 0.00, 2327.00, 8.22, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860905836394577920, 1, '2024-11-25 12:38:20', '2024-11-25 12:38:00', '2024-11-25 12:38:01', '2000-01-05 04:21:35', 2, 0, 0, '01:29:10', '21:30:50', 35.00, 35.00, 0.00, 0.00, 0.00, 2328.00, 8.26, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860905962227892224, 1, '2024-11-25 12:38:50', '2024-11-25 12:38:30', '2024-11-25 12:38:31', '2000-01-05 04:22:05', 2, 0, 0, '01:29:40', '21:30:20', 35.00, 35.00, 0.00, 0.00, 0.00, 2326.00, 8.31, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860906088052817920, 1, '2024-11-25 12:39:20', '2024-11-25 12:39:00', '2024-11-25 12:39:01', '2000-01-05 04:22:35', 2, 0, 0, '01:30:10', '21:29:50', 35.00, 35.00, 0.00, 0.00, 0.00, 2327.00, 8.30, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860906213881937920, 1, '2024-11-25 12:39:50', '2024-11-25 12:39:30', '2024-11-25 12:39:31', '2000-01-05 04:23:05', 2, 0, 0, '01:30:40', '21:29:20', 35.00, 35.00, 0.00, 0.00, 0.00, 2329.00, 8.35, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860906339711057920, 1, '2024-11-25 12:40:20', '2024-11-25 12:40:00', '2024-11-25 12:40:02', '2000-01-05 04:23:36', 2, 0, 0, '01:31:11', '21:28:49', 35.00, 35.00, 0.00, 0.00, 0.00, 2326.00, 8.38, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860906465544372224, 1, '2024-11-25 12:40:50', '2024-11-25 12:40:30', '2024-11-25 12:40:32', '2000-01-05 04:24:06', 2, 0, 0, '01:31:41', '21:28:19', 35.00, 35.00, 0.00, 0.00, 0.00, 2328.00, 8.42, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860906591365103616, 1, '2024-11-25 12:41:20', '2024-11-25 12:41:00', '2024-11-25 12:41:02', '2000-01-05 04:24:36', 2, 0, 0, '01:32:11', '21:27:49', 35.00, 35.00, 0.00, 0.00, 0.00, 2328.00, 8.43, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860906717202612224, 1, '2024-11-25 12:41:50', '2024-11-25 12:41:30', '2024-11-25 12:41:31', '2000-01-05 04:25:05', 2, 0, 0, '01:32:40', '21:27:20', 35.00, 35.00, 0.00, 0.00, 0.00, 2327.00, 8.40, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860906843027537920, 1, '2024-11-25 12:42:20', '2024-11-25 12:42:00', '2024-11-25 12:42:02', '2000-01-05 04:25:36', 2, 0, 0, '01:33:11', '21:26:49', 35.00, 35.00, 0.00, 0.00, 0.00, 2329.00, 8.42, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860906968856657920, 1, '2024-11-25 12:42:50', '2024-11-25 12:42:30', '2024-11-25 12:42:31', '2000-01-05 04:26:06', 2, 0, 0, '01:33:41', '21:26:19', 35.00, 35.00, 0.00, 0.00, 0.00, 2330.00, 8.44, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860907094685777920, 1, '2024-11-25 12:43:20', '2024-11-25 12:43:00', '2024-11-25 12:43:02', '2000-01-05 04:26:36', 2, 0, 0, '01:34:11', '21:25:49', 35.00, 35.00, 0.00, 0.00, 0.00, 2330.00, 8.45, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860907220510703616, 1, '2024-11-25 12:43:50', '2024-11-25 12:43:30', '2024-11-25 12:43:31', '2000-01-05 04:27:05', 2, 0, 0, '01:34:40', '21:25:20', 35.00, 35.00, 0.00, 0.00, 0.00, 2331.00, 8.46, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860907346344017920, 1, '2024-11-25 12:44:20', '2024-11-25 12:44:00', '2024-11-25 12:44:02', '2000-01-05 04:27:36', 2, 0, 0, '01:35:11', '21:24:49', 35.00, 35.00, 0.00, 0.00, 0.00, 2331.00, 8.52, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860907472168943616, 1, '2024-11-25 12:44:50', '2024-11-25 12:44:30', '2024-11-25 12:44:32', '2000-01-05 04:28:06', 2, 0, 0, '01:35:41', '21:24:19', 35.00, 35.00, 0.00, 0.00, 0.00, 2333.00, 8.53, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860907598002257920, 1, '2024-11-25 12:45:20', '2024-11-25 12:45:00', '2024-11-25 12:45:01', '2000-01-05 04:28:35', 2, 0, 0, '01:36:10', '21:23:50', 35.00, 35.00, 0.00, 0.00, 0.00, 2332.00, 8.57, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860907723827183616, 1, '2024-11-25 12:45:50', '2024-11-25 12:45:30', '2024-11-25 12:45:31', '2000-01-05 04:29:05', 2, 0, 0, '01:36:40', '21:23:20', 35.00, 35.00, 0.00, 0.00, 0.00, 2332.00, 8.59, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860907849660497920, 1, '2024-11-25 12:46:20', '2024-11-25 12:46:00', '2024-11-25 12:46:01', '2000-01-05 04:29:35', 2, 0, 0, '01:37:10', '21:22:50', 35.00, 35.00, 0.00, 0.00, 0.00, 2332.00, 8.61, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860907975493812224, 1, '2024-11-25 12:46:50', '2024-11-25 12:46:30', '2024-11-25 12:46:31', '2000-01-05 04:30:05', 2, 0, 0, '01:37:40', '21:22:20', 35.00, 35.00, 0.00, 0.00, 0.00, 2333.00, 8.66, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860908101318737920, 1, '2024-11-25 12:47:20', '2024-11-25 12:47:00', '2024-11-25 12:47:01', '2000-01-05 04:30:35', 2, 0, 0, '01:38:10', '21:21:50', 35.00, 35.00, 0.00, 0.00, 0.00, 2337.00, 8.64, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860908227152052224, 1, '2024-11-25 12:47:50', '2024-11-25 12:47:30', '2024-11-25 12:47:31', '2000-01-05 04:31:05', 2, 0, 0, '01:38:40', '21:21:20', 35.00, 35.00, 0.00, 0.00, 0.00, 2336.00, 8.60, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860908352981172224, 1, '2024-11-25 12:48:20', '2024-11-25 12:48:00', '2024-11-25 12:48:02', '2000-01-05 04:31:36', 2, 0, 0, '01:39:11', '21:20:49', 35.00, 35.00, 0.00, 0.00, 0.00, 2336.00, 8.62, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860908478801903616, 1, '2024-11-25 12:48:50', '2024-11-25 12:48:30', '2024-11-25 12:48:32', '2000-01-05 04:32:06', 2, 0, 0, '01:39:41', '21:20:19', 35.00, 35.00, 0.00, 0.00, 0.00, 2338.00, 8.56, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860908604631023616, 1, '2024-11-25 12:49:20', '2024-11-25 12:49:00', '2024-11-25 12:49:02', '2000-01-05 04:32:36', 2, 0, 0, '01:40:11', '21:19:49', 35.00, 35.00, 0.00, 0.00, 0.00, 2337.00, 8.61, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860908730464337920, 1, '2024-11-25 12:49:50', '2024-11-25 12:49:30', '2024-11-25 12:49:31', '2000-01-05 04:33:05', 2, 0, 0, '01:40:40', '21:19:20', 35.00, 35.00, 0.00, 0.00, 0.00, 2338.00, 8.61, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860908856297652224, 1, '2024-11-25 12:50:20', '2024-11-25 12:50:00', '2024-11-25 12:50:02', '2000-01-05 04:33:36', 2, 0, 0, '01:41:11', '21:18:49', 35.00, 35.00, 0.00, 0.00, 0.00, 2340.00, 8.57, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860908982122577920, 1, '2024-11-25 12:50:50', '2024-11-25 12:50:30', '2024-11-25 12:50:31', '2000-01-05 04:34:06', 2, 0, 0, '01:41:40', '21:18:20', 35.00, 35.00, 0.00, 0.00, 0.00, 2339.00, 8.57, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860909107951697920, 1, '2024-11-25 12:51:20', '2024-11-25 12:51:00', '2024-11-25 12:51:02', '2000-01-05 04:34:36', 2, 0, 0, '01:42:11', '21:17:49', 35.00, 35.00, 0.00, 0.00, 0.00, 2342.00, 8.46, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860909233780817920, 1, '2024-11-25 12:51:50', '2024-11-25 12:51:30', '2024-11-25 12:51:32', '2000-01-05 04:35:05', 2, 0, 0, '01:42:40', '21:17:20', 35.00, 35.00, 0.00, 0.00, 0.00, 2343.00, 8.46, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860909359605743616, 1, '2024-11-25 12:52:20', '2024-11-25 12:52:00', '2024-11-25 12:52:02', '2000-01-05 04:35:36', 2, 0, 0, '01:43:11', '21:16:49', 35.00, 35.00, 0.00, 0.00, 0.00, 2343.00, 8.48, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860909485434863616, 1, '2024-11-25 12:52:50', '2024-11-25 12:52:30', '2024-11-25 12:52:32', '2000-01-05 04:36:06', 2, 0, 0, '01:43:41', '21:16:19', 35.00, 35.00, 0.00, 0.00, 0.00, 2345.00, 8.45, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860909611268177920, 1, '2024-11-25 12:53:20', '2024-11-25 12:53:00', '2024-11-25 12:53:04', '2000-01-05 04:36:35', 2, 0, 0, '01:44:10', '21:15:50', 35.00, 35.00, 0.00, 0.00, 0.00, 2344.00, 8.48, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860909862922223616, 1, '2024-11-25 12:54:20', '2024-11-25 12:54:00', '2024-11-25 12:54:01', '2000-01-05 04:37:35', 2, 0, 0, '01:45:10', '21:14:50', 35.00, 35.00, 0.00, 0.00, 0.00, 2347.00, 8.44, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860909988755537920, 1, '2024-11-25 12:54:50', '2024-11-25 12:54:30', '2024-11-25 12:54:32', '2000-01-05 04:38:06', 2, 0, 0, '01:45:41', '21:14:19', 35.00, 35.00, 0.00, 0.00, 0.00, 2345.00, 8.40, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860910114580463616, 1, '2024-11-25 12:55:20', '2024-11-25 12:55:00', '2024-11-25 12:55:02', '2000-01-05 04:38:36', 2, 0, 0, '01:46:11', '21:13:49', 35.00, 35.00, 0.00, 0.00, 0.00, 2347.00, 8.34, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860910240413777920, 1, '2024-11-25 12:55:50', '2024-11-25 12:55:30', '2024-11-25 12:55:31', '2000-01-05 04:39:05', 2, 0, 0, '01:46:40', '21:13:20', 35.00, 35.00, 0.00, 0.00, 0.00, 2346.00, 8.26, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860910366242897920, 1, '2024-11-25 12:56:20', '2024-11-25 12:56:00', '2024-11-25 12:56:01', '2000-01-05 04:39:35', 2, 0, 0, '01:47:10', '21:12:50', 35.00, 35.00, 0.00, 0.00, 0.00, 2347.00, 8.64, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860910492067823616, 1, '2024-11-25 12:56:50', '2024-11-25 12:56:30', '2024-11-25 12:56:31', '2000-01-05 04:40:05', 2, 0, 0, '01:47:40', '21:12:20', 35.00, 35.00, 0.00, 0.00, 0.00, 2355.00, 8.56, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860910617905332224, 1, '2024-11-25 12:57:20', '2024-11-25 12:57:00', '2024-11-25 12:57:01', '2000-01-05 04:40:35', 2, 0, 0, '01:48:10', '21:11:50', 35.00, 35.00, 0.00, 0.00, 0.00, 2364.00, 8.45, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860910743738646528, 1, '2024-11-25 12:57:50', '2024-11-25 12:57:30', '2024-11-25 12:57:34', '2000-01-05 04:41:05', 2, 0, 0, '01:48:40', '21:11:20', 35.00, 35.00, 0.00, 0.00, 0.00, 2368.00, 8.45, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860910869559377920, 1, '2024-11-25 12:58:20', '2024-11-25 12:58:00', '2024-11-25 12:58:02', '2000-01-05 04:41:36', 2, 0, 0, '01:49:11', '21:10:49', 35.00, 35.00, 0.00, 0.00, 0.00, 2368.00, 8.62, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860910995388497920, 1, '2024-11-25 12:58:50', '2024-11-25 12:58:30', '2024-11-25 12:58:31', '2024-11-25 12:58:47', 2, 0, 0, '01:49:40', '21:10:20', 35.00, 35.00, 0.00, 0.00, 0.00, 2376.00, 8.76, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860911121213423616, 1, '2024-11-25 12:59:20', '2024-11-25 12:59:00', '2024-11-25 12:59:01', '2024-11-25 12:59:16', 2, 0, 0, '01:50:09', '21:09:51', 35.00, 35.00, 0.00, 0.00, 0.00, 2381.00, 8.31, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860912758736814080, 1, '2024-11-25 13:05:50', '2024-11-25 13:03:00', '2024-11-25 13:03:01', '2024-11-25 13:05:46', 2, 0, 0, '01:56:39', '21:03:21', 35.00, 35.00, 0.00, 0.00, 0.00, 2372.00, 8.07, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860913136282894336, 1, '2024-11-25 13:07:20', '2024-11-25 13:01:00', '2024-11-25 13:01:01', '2024-11-25 13:07:16', 2, 0, 0, '01:58:09', '21:01:51', 35.00, 35.00, 0.00, 0.00, 0.00, 2369.00, 8.00, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860914016243679232, 1, '2024-11-25 13:10:50', '2024-11-25 13:10:30', '2024-11-25 13:10:32', '2024-11-25 13:10:48', 2, 0, 0, '02:01:40', '20:58:20', 35.00, 35.00, 0.00, 0.00, 0.00, 2370.00, 8.14, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860914141150052352, 1, '2024-11-25 13:11:20', '2024-11-25 13:11:00', '2024-11-25 13:11:01', '2024-11-25 13:11:17', 2, 0, 0, '02:02:10', '20:57:50', 35.00, 35.00, 0.00, 0.00, 0.00, 2372.00, 8.20, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860914266970783744, 1, '2024-11-25 13:11:50', '2024-11-25 13:11:30', '2024-11-25 13:11:32', '2024-11-25 13:11:48', 2, 0, 0, '02:02:40', '20:57:20', 35.00, 35.00, 0.00, 0.00, 0.00, 2374.00, 8.25, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860914392804098048, 1, '2024-11-25 13:12:20', '2024-11-25 13:12:00', '2024-11-25 13:12:02', '2024-11-25 13:12:17', 2, 0, 0, '02:03:10', '20:56:50', 35.00, 35.00, 0.00, 0.00, 0.00, 2373.00, 8.27, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860914518633218048, 1, '2024-11-25 13:12:50', '2024-11-25 13:12:30', '2024-11-25 13:12:32', '2024-11-25 13:12:48', 2, 0, 0, '02:03:41', '20:56:19', 35.00, 35.00, 0.00, 0.00, 0.00, 2373.00, 8.26, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860914644453949440, 1, '2024-11-25 13:13:20', '2024-11-25 13:13:00', '2024-11-25 13:13:02', '2024-11-25 13:13:17', 2, 0, 0, '02:04:10', '20:55:50', 35.00, 35.00, 0.00, 0.00, 0.00, 2374.00, 8.23, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860914770283069440, 1, '2024-11-25 13:13:50', '2024-11-25 13:13:30', '2024-11-25 13:13:31', '2024-11-25 13:13:47', 2, 0, 0, '02:04:40', '20:55:20', 35.00, 35.00, 0.00, 0.00, 0.00, 2374.00, 8.22, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860914896116383744, 1, '2024-11-25 13:14:20', '2024-11-25 13:14:00', '2024-11-25 13:14:01', '2024-11-25 13:14:16', 2, 0, 0, '02:05:09', '20:54:51', 35.00, 35.00, 0.00, 0.00, 0.00, 2373.00, 8.24, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860915021945503744, 1, '2024-11-25 13:14:50', '2024-11-25 13:14:30', '2024-11-25 13:14:31', '2024-11-25 13:14:46', 2, 0, 0, '02:05:39', '20:54:21', 35.00, 35.00, 0.00, 0.00, 0.00, 2374.00, 8.26, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860915147766235136, 1, '2024-11-25 13:15:20', '2024-11-25 13:15:00', '2024-11-25 13:15:04', '2024-11-25 13:14:46', 2, 0, 0, '02:05:39', '20:54:21', 35.00, 35.00, 0.00, 0.00, 0.00, 2374.00, 8.26, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860915273599549440, 1, '2024-11-25 13:15:50', '2024-11-25 13:15:30', '2024-11-25 13:15:31', '2024-11-25 13:15:47', 2, 0, 0, '02:06:40', '20:53:20', 35.00, 35.00, 0.00, 0.00, 0.00, 2373.00, 8.27, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860915399424475136, 1, '2024-11-25 13:16:20', '2024-11-25 13:16:00', '2024-11-25 13:16:01', '2024-11-25 13:16:16', 2, 0, 0, '02:07:09', '20:52:51', 35.00, 35.00, 0.00, 0.00, 0.00, 2373.00, 8.29, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860915525257789440, 1, '2024-11-25 13:16:50', '2024-11-25 13:16:30', '2024-11-25 13:16:31', '2024-11-25 13:16:47', 2, 0, 0, '02:07:40', '20:52:20', 35.00, 35.00, 0.00, 0.00, 0.00, 2372.00, 8.29, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860915651086909440, 1, '2024-11-25 13:17:20', '2024-11-25 13:17:00', '2024-11-25 13:17:01', '2024-11-25 13:17:17', 2, 0, 0, '02:08:09', '20:51:51', 35.00, 35.00, 0.00, 0.00, 0.00, 2372.00, 8.37, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860915777029275648, 1, '2024-11-25 13:17:50', '2024-11-25 13:17:30', '2024-11-25 13:17:30', '2024-11-25 13:17:46', 2, 0, 0, '02:08:39', '20:51:21', 35.00, 35.00, 0.00, 0.00, 0.00, 2373.00, 8.87, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860915902745149440, 1, '2024-11-25 13:18:20', '2024-11-25 13:18:00', '2024-11-25 13:18:04', '2024-11-25 13:18:17', 2, 0, 0, '02:09:10', '20:50:50', 35.00, 35.00, 0.00, 0.00, 0.00, 2383.00, 8.66, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860916028574269440, 1, '2024-11-25 13:18:50', '2024-11-25 13:18:30', '2024-11-25 13:18:32', '2024-11-25 13:18:48', 2, 0, 0, '02:09:41', '20:50:19', 35.00, 35.00, 0.00, 0.00, 0.00, 2393.00, 8.57, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860916154399195136, 1, '2024-11-25 13:19:20', '2024-11-25 13:19:00', '2024-11-25 13:19:04', '2024-11-25 13:19:17', 2, 0, 0, '02:10:10', '20:49:50', 35.00, 35.00, 0.00, 0.00, 0.00, 2391.00, 8.32, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860916280215732224, 1, '2024-11-25 13:19:50', '2024-11-25 13:19:30', '2024-11-25 13:19:32', '2024-11-25 13:19:48', 2, 0, 0, '02:10:41', '20:49:19', 35.00, 35.00, 0.00, 0.00, 0.00, 2388.00, 8.40, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860916406053240832, 1, '2024-11-25 13:20:20', '2024-11-25 13:20:00', '2024-11-25 13:20:04', '2024-11-25 13:20:17', 2, 0, 0, '02:11:10', '20:48:50', 35.00, 35.00, 0.00, 0.00, 0.00, 2388.00, 8.28, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860916531882360832, 1, '2024-11-25 13:20:50', '2024-11-25 13:20:30', '2024-11-25 13:20:32', '2024-11-25 13:20:48', 2, 0, 0, '02:11:41', '20:48:19', 35.00, 35.00, 0.00, 0.00, 0.00, 2385.00, 8.26, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860916657715675136, 1, '2024-11-25 13:21:20', '2024-11-25 13:21:00', '2024-11-25 13:21:02', '2024-11-25 13:21:18', 2, 0, 0, '02:12:10', '20:47:50', 35.00, 35.00, 0.00, 0.00, 0.00, 2384.00, 8.23, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860916783540600832, 1, '2024-11-25 13:21:50', '2024-11-25 13:21:30', '2024-11-25 13:21:31', '2024-11-25 13:21:47', 2, 0, 0, '02:12:40', '20:47:20', 35.00, 35.00, 0.00, 0.00, 0.00, 2385.00, 8.16, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860916909373915136, 1, '2024-11-25 13:22:20', '2024-11-25 13:22:00', '2024-11-25 13:22:02', '2024-11-25 13:22:17', 2, 0, 0, '02:13:10', '20:46:50', 35.00, 35.00, 0.00, 0.00, 0.00, 2383.00, 8.16, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860917035198840832, 1, '2024-11-25 13:22:50', '2024-11-25 13:22:30', '2024-11-25 13:22:31', '2024-11-25 13:22:47', 2, 0, 0, '02:13:40', '20:46:20', 35.00, 35.00, 0.00, 0.00, 0.00, 2386.00, 8.13, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860917161032155136, 1, '2024-11-25 13:23:20', '2024-11-25 13:23:00', '2024-11-25 13:23:02', '2024-11-25 13:23:18', 2, 0, 0, '02:14:11', '20:45:49', 35.00, 35.00, 0.00, 0.00, 0.00, 2384.00, 8.15, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860917286852886528, 1, '2024-11-25 13:23:50', '2024-11-25 13:23:30', '2024-11-25 13:23:32', '2024-11-25 13:23:47', 2, 0, 0, '02:14:40', '20:45:20', 35.00, 35.00, 0.00, 0.00, 0.00, 2386.00, 8.09, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860917412690395136, 1, '2024-11-25 13:24:20', '2024-11-25 13:24:00', '2024-11-25 13:24:02', '2024-11-25 13:24:18', 2, 0, 0, '02:15:11', '20:44:49', 35.00, 35.00, 0.00, 0.00, 0.00, 2392.00, 8.34, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860917538515320832, 1, '2024-11-25 13:24:50', '2024-11-25 13:24:30', '2024-11-25 13:24:32', '2024-11-25 13:24:47', 2, 0, 0, '02:15:40', '20:44:20', 35.00, 35.00, 0.00, 0.00, 0.00, 2401.00, 8.31, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860917664344440832, 1, '2024-11-25 13:25:20', '2024-11-25 13:25:00', '2024-11-25 13:25:01', '2024-11-25 13:25:16', 2, 0, 0, '02:16:09', '20:43:51', 35.00, 35.00, 0.00, 0.00, 0.00, 2408.00, 8.52, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860917790177755136, 1, '2024-11-25 13:25:50', '2024-11-25 13:25:30', '2024-11-25 13:25:31', '2024-11-25 13:25:47', 2, 0, 0, '02:16:40', '20:43:20', 35.00, 35.00, 0.00, 0.00, 0.00, 2413.00, 8.04, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860917915998486528, 1, '2024-11-25 13:26:20', '2024-11-25 13:26:00', '2024-11-25 13:26:01', '2024-11-25 13:26:16', 2, 1, 0, '00:00:23', '00:59:37', 35.00, 35.00, 0.00, 0.00, 0.00, 2418.00, 7.99, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860918041831800832, 1, '2024-11-25 13:26:50', '2024-11-25 13:26:30', '2024-11-25 13:26:31', '2024-11-25 13:26:47', 2, 1, 0, '00:00:54', '00:59:06', 35.00, 35.00, 0.00, 0.00, 0.00, 2421.00, 8.10, 2, 1, 1, '06:00:07', '00:00:00', '00:00:00', '00:00:00', '01:00:00', '23:00:00', '01:04:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860918167644143616, 1, '2024-11-25 13:27:20', '2024-11-25 13:27:00', '2024-11-25 13:27:00', '2024-11-25 13:27:17', 4, 0, 0, '00:00:10', '23:18:18', 35.00, 35.00, 0.00, 0.00, 0.00, 2316.00, 7.16, 2, 1, 1, '10:05:30', '11:30:00', '17:45:00', '18:00:00', '01:30:00', '23:30:00', '01:35:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
INSERT INTO `t_device_data_1` (`id`, `device_id`, `created_time`, `collection_time`, `receive_time`, `device_time`, `run_mode`, `gas_status`, `plug_status`, `status_start_time`, `status_end_time`, `oil_pressure`, `cas_pressure`, `pre_pressure`, `pipe_pressure`, `liquid_level`, `temperature`, `humidity`, `op_mode`, `timer_able1`, `timer_able2`, `timer_open1`, `timer_close1`, `timer_open2`, `timer_close2`, `timing_open`, `timing_close`, `timing_delay`, `presource`, `pressure_open`, `pressure_close`, `trigger_type`, `stability_time`, `max_open_well`, `max_close_well`, `min_open_well`, `min_close_well`, `prespro_tect`, `prespro_source`, `open_well_limit_max`, `open_well_limit_min`, `plug_init_status`, `plug_sustain_time`, `plug_close_time`, `tp_init_status`, `tp_open_source`, `tp_open_trigger`, `tp_open_pressure`, `tp_open_time`, `tp_close_source`, `tp_close_trigger`, `tp_close_pressure`, `tp_close_time`, `tp_stability_time`) VALUES (1860918293481652224, 1, '2024-11-25 13:27:50', '2024-11-25 13:27:30', '2024-11-25 13:27:31', '2024-11-25 13:27:48', 4, 0, 0, '00:00:10', '23:17:48', 35.00, 35.00, 0.00, 0.00, 0.00, 2314.00, 7.09, 2, 1, 1, '10:05:30', '11:30:00', '17:45:00', '18:00:00', '01:30:00', '23:30:00', '01:35:00', 0, 10.00, 1.00, 0, 10, '999:59:59', '999:59:59', '00:01:00', '00:01:00', 1, 1, 99.99, 0.00, 0, '999:59:59', '999:59:59', 0, 0, 0, 9999, '999:59:59', 0, 1, 100, '999:59:59', 10);
COMMIT;

-- ----------------------------
-- Table structure for user
-- ----------------------------
DROP TABLE IF EXISTS `user`;
CREATE TABLE `user` (
                        `id` bigint NOT NULL,
                        `username` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci DEFAULT NULL COMMENT '账户',
                        `password` text CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci COMMENT '密码',
                        `nickname` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci DEFAULT NULL COMMENT '昵称',
                        `phone` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci DEFAULT NULL COMMENT '手机号',
                        `picture` text CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci COMMENT '头像',
                        `is_enable` char(1) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci DEFAULT NULL COMMENT '是否启用（1启用，0冻结）',
                        `create_time` timestamp NULL DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间',
                        `update_time` timestamp NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '更新时间',
                        PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci COMMENT='用户表';

-- ----------------------------
-- Records of user
-- ----------------------------
BEGIN;
INSERT INTO `user` (`id`, `username`, `password`, `nickname`, `phone`, `picture`, `is_enable`, `create_time`, `update_time`) VALUES (1, 'admin', '7c4a8d09ca3762af61e59520943dc26494f8941b', 'admin', '13028138200', NULL, '1', '2024-08-30 10:17:10', '2024-10-25 10:14:24');
INSERT INTO `user` (`id`, `username`, `password`, `nickname`, `phone`, `picture`, `is_enable`, `create_time`, `update_time`) VALUES (1850801224132067328, 'test1', '7c4a8d09ca3762af61e59520943dc26494f8941b', '张四', '13012341234', NULL, '1', '2024-10-28 15:26:12', '2024-10-28 15:56:52');
INSERT INTO `user` (`id`, `username`, `password`, `nickname`, `phone`, `picture`, `is_enable`, `create_time`, `update_time`) VALUES (1850812935484473344, 'test2', '7c4a8d09ca3762af61e59520943dc26494f8941b', '王五', '13012341235', NULL, '1', '2024-10-28 16:12:44', '2024-10-28 16:12:44');
INSERT INTO `user` (`id`, `username`, `password`, `nickname`, `phone`, `picture`, `is_enable`, `create_time`, `update_time`) VALUES (1853726975508611072, '123d', '7c4a8d09ca3762af61e59520943dc26494f8941b', '123dd', '13333333331', NULL, '1', '2024-11-05 17:12:06', '2024-11-23 18:39:45');
INSERT INTO `user` (`id`, `username`, `password`, `nickname`, `phone`, `picture`, `is_enable`, `create_time`, `update_time`) VALUES (1859282476250169344, '123dd', '7c4a8d09ca3762af61e59520943dc26494f8941b', '安定', '13333333333', NULL, '1', '2024-11-21 01:07:40', '2024-11-21 01:07:40');
INSERT INTO `user` (`id`, `username`, `password`, `nickname`, `phone`, `picture`, `is_enable`, `create_time`, `update_time`) VALUES (1859283318915203072, 'dfg2', '7c4a8d09ca3762af61e59520943dc26494f8941b', '213安定', '13999999999', NULL, '1', '2024-11-21 01:11:01', '2024-11-21 01:11:01');
COMMIT;

-- ----------------------------
-- Table structure for user_department
-- ----------------------------
DROP TABLE IF EXISTS `user_department`;
CREATE TABLE `user_department` (
                                   `id` bigint NOT NULL,
                                   `user_id` bigint DEFAULT NULL COMMENT '用户id',
                                   `department_id` bigint DEFAULT NULL COMMENT '部门id',
                                   `create_time` timestamp NULL DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间',
                                   `update_time` timestamp NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '更新时间',
                                   PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci COMMENT='用户部门关联表';

-- ----------------------------
-- Records of user_department
-- ----------------------------
BEGIN;
INSERT INTO `user_department` (`id`, `user_id`, `department_id`, `create_time`, `update_time`) VALUES (1857847465089171456, 1850812935484473344, 1, '2024-11-17 02:05:27', '2024-11-17 02:05:27');
INSERT INTO `user_department` (`id`, `user_id`, `department_id`, `create_time`, `update_time`) VALUES (1859278803252019200, 1853726975508611072, 2, '2024-11-21 00:53:05', '2024-11-21 00:53:05');
INSERT INTO `user_department` (`id`, `user_id`, `department_id`, `create_time`, `update_time`) VALUES (1859282476338249728, 1859282476250169344, 2, '2024-11-21 01:07:40', '2024-11-21 01:07:40');
INSERT INTO `user_department` (`id`, `user_id`, `department_id`, `create_time`, `update_time`) VALUES (1859283318936174592, 1859283318915203072, 1, '2024-11-21 01:11:01', '2024-11-21 01:11:01');
COMMIT;

-- ----------------------------
-- Table structure for user_operation_record
-- ----------------------------
DROP TABLE IF EXISTS `user_operation_record`;
CREATE TABLE `user_operation_record` (
                                         `id` bigint NOT NULL,
                                         `type` int DEFAULT NULL COMMENT '日志类型（1登录 ）',
                                         `name` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci DEFAULT NULL COMMENT '日志标题',
                                         `username` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci DEFAULT NULL COMMENT '用户名',
                                         `uri` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci DEFAULT NULL COMMENT '请求地址',
                                         `menu` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci DEFAULT NULL COMMENT '菜单',
                                         `request` text CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci COMMENT '请求参数',
                                         `request_type` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci DEFAULT NULL COMMENT '请求类型',
                                         `error_msg` text CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci COMMENT '错误消息',
                                         `cost_time` bigint DEFAULT NULL COMMENT '请求时间',
                                         `result` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci DEFAULT NULL COMMENT '请求结果（0成功，1失败）',
                                         `ip` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci DEFAULT NULL COMMENT '登录ip',
                                         `create_time` timestamp NULL DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间',
                                         `update_time` timestamp NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '更新时间',
                                         PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci COMMENT='用户操作记录表';

-- ----------------------------
-- Records of user_operation_record
-- ----------------------------
BEGIN;
INSERT INTO `user_operation_record` (`id`, `type`, `name`, `username`, `uri`, `menu`, `request`, `request_type`, `error_msg`, `cost_time`, `result`, `ip`, `create_time`, `update_time`) VALUES (1860956220458795008, 0, NULL, '123d', '/user/doLogin', NULL, '[LoginDTO(username=123d, password=7c4a8d09ca3762af61e59520943dc26494f8941b)]', NULL, NULL, NULL, '0', '127.0.0.1', '2024-11-25 15:59:00', '2024-11-25 15:59:00');
INSERT INTO `user_operation_record` (`id`, `type`, `name`, `username`, `uri`, `menu`, `request`, `request_type`, `error_msg`, `cost_time`, `result`, `ip`, `create_time`, `update_time`) VALUES (1860956297784983552, 2, NULL, '123d', '/device/add', NULL, '[DeviceCreateDTO(deviceType=1, code=2, gasStation=苏7-223, product=4, gatewaySn=sldfks, details=456456, gasWell=1860586124699762688)]', NULL, NULL, NULL, '0', '127.0.0.1', '2024-11-25 15:59:00', '2024-11-25 15:59:00');
INSERT INTO `user_operation_record` (`id`, `type`, `name`, `username`, `uri`, `menu`, `request`, `request_type`, `error_msg`, `cost_time`, `result`, `ip`, `create_time`, `update_time`) VALUES (1860956436171849728, 2, NULL, '123d', '/device/add', NULL, '[DeviceCreateDTO(deviceType=1, code=2, gasStation=苏7-223, product=4, gatewaySn=sldfks, details=456456, gasWell=1860586124699762688)]', NULL, NULL, NULL, '1', '127.0.0.1', '2024-11-25 16:00:00', '2024-11-25 16:00:00');
INSERT INTO `user_operation_record` (`id`, `type`, `name`, `username`, `uri`, `menu`, `request`, `request_type`, `error_msg`, `cost_time`, `result`, `ip`, `create_time`, `update_time`) VALUES (1860957701694029824, 0, NULL, '123d', '/user/doLogin', NULL, '[LoginDTO(username=123d, password=7c4a8d09ca3762af61e59520943dc26494f8941b)]', NULL, NULL, NULL, '0', '127.0.0.1', '2024-11-25 16:05:00', '2024-11-25 16:05:00');
INSERT INTO `user_operation_record` (`id`, `type`, `name`, `username`, `uri`, `menu`, `request`, `request_type`, `error_msg`, `cost_time`, `result`, `ip`, `create_time`, `update_time`) VALUES (1860957771269144576, 2, NULL, '123d', '/device/add', NULL, '[DeviceCreateDTO(deviceType=1, code=2, gasStation=苏7-223, product=4, gatewaySn=sldfks, details=456456, gasWell=1860586124699762688)]', NULL, NULL, NULL, '1', '127.0.0.1', '2024-11-25 16:05:00', '2024-11-25 16:05:00');
INSERT INTO `user_operation_record` (`id`, `type`, `name`, `username`, `uri`, `menu`, `request`, `request_type`, `error_msg`, `cost_time`, `result`, `ip`, `create_time`, `update_time`) VALUES (1860957820606742528, 2, NULL, '123d', '/device/add', NULL, '[DeviceCreateDTO(deviceType=1, code=4, gasStation=苏7-223, product=4, gatewaySn=sldfks, details=456456, gasWell=1860586124699762688)]', NULL, NULL, NULL, '1', '127.0.0.1', '2024-11-25 16:05:00', '2024-11-25 16:05:00');
INSERT INTO `user_operation_record` (`id`, `type`, `name`, `username`, `uri`, `menu`, `request`, `request_type`, `error_msg`, `cost_time`, `result`, `ip`, `create_time`, `update_time`) VALUES (1860957943705370624, 2, NULL, '123d', '/device/add', NULL, '[DeviceCreateDTO(deviceType=1, code=4, gasStation=苏7-223, product=4, gatewaySn=sldfks, details=456456, gasWell=1860586124699762688)]', NULL, NULL, NULL, '1', '127.0.0.1', '2024-11-25 16:06:00', '2024-11-25 16:06:00');
INSERT INTO `user_operation_record` (`id`, `type`, `name`, `username`, `uri`, `menu`, `request`, `request_type`, `error_msg`, `cost_time`, `result`, `ip`, `create_time`, `update_time`) VALUES (1860958016409436160, 2, NULL, '123d', '/device/add', NULL, '[DeviceCreateDTO(deviceType=1, code=4, gasStation=苏7-223, product=4, gatewaySn=sldfks, details=456456, gasWell=1860588309223309312)]', NULL, NULL, NULL, '0', '127.0.0.1', '2024-11-25 16:06:00', '2024-11-25 16:06:00');
INSERT INTO `user_operation_record` (`id`, `type`, `name`, `username`, `uri`, `menu`, `request`, `request_type`, `error_msg`, `cost_time`, `result`, `ip`, `create_time`, `update_time`) VALUES (1861019110113017856, 0, NULL, '123d', '/user/doLogin', NULL, '[LoginDTO(username=123d, password=7c4a8d09ca3762af61e59520943dc26494f8941b)]', NULL, NULL, NULL, '0', '127.0.0.1', '2024-11-25 20:09:00', '2024-11-25 20:09:00');
INSERT INTO `user_operation_record` (`id`, `type`, `name`, `username`, `uri`, `menu`, `request`, `request_type`, `error_msg`, `cost_time`, `result`, `ip`, `create_time`, `update_time`) VALUES (1861019932632809472, 0, NULL, '123d', '/user/doLogin', NULL, '[LoginDTO(username=123d, password=7c4a8d09ca3762af61e59520943dc26494f8941b)]', NULL, NULL, NULL, '0', '127.0.0.1', '2024-11-25 20:12:00', '2024-11-25 20:12:00');
INSERT INTO `user_operation_record` (`id`, `type`, `name`, `username`, `uri`, `menu`, `request`, `request_type`, `error_msg`, `cost_time`, `result`, `ip`, `create_time`, `update_time`) VALUES (1861060140334055424, 0, NULL, '123d', '/user/doLogin', NULL, '[LoginDTO(username=123d, password=7c4a8d09ca3762af61e59520943dc26494f8941b)]', NULL, NULL, NULL, '0', '127.0.0.1', '2024-11-25 22:52:00', '2024-11-25 22:52:00');
INSERT INTO `user_operation_record` (`id`, `type`, `name`, `username`, `uri`, `menu`, `request`, `request_type`, `error_msg`, `cost_time`, `result`, `ip`, `create_time`, `update_time`) VALUES (1861061435002454016, 0, NULL, '123d', '/user/doLogin', NULL, '[LoginDTO(username=123d, password=7c4a8d09ca3762af61e59520943dc26494f8941b)]', NULL, NULL, NULL, '0', '127.0.0.1', '2024-11-25 22:57:00', '2024-11-25 22:57:00');
INSERT INTO `user_operation_record` (`id`, `type`, `name`, `username`, `uri`, `menu`, `request`, `request_type`, `error_msg`, `cost_time`, `result`, `ip`, `create_time`, `update_time`) VALUES (1861062064076750848, 0, NULL, '123d', '/user/doLogin', NULL, '[LoginDTO(username=123d, password=7c4a8d09ca3762af61e59520943dc26494f8941b)]', NULL, NULL, NULL, '0', '127.0.0.1', '2024-11-25 23:00:00', '2024-11-25 23:00:00');
INSERT INTO `user_operation_record` (`id`, `type`, `name`, `username`, `uri`, `menu`, `request`, `request_type`, `error_msg`, `cost_time`, `result`, `ip`, `create_time`, `update_time`) VALUES (1861095013228740608, 0, NULL, '123d', '/user/doLogin', NULL, '[LoginDTO(username=123d, password=7c4a8d09ca3762af61e59520943dc26494f8941b)]', NULL, NULL, NULL, '0', '127.0.0.1', '2024-11-26 01:11:00', '2024-11-26 01:11:00');
INSERT INTO `user_operation_record` (`id`, `type`, `name`, `username`, `uri`, `menu`, `request`, `request_type`, `error_msg`, `cost_time`, `result`, `ip`, `create_time`, `update_time`) VALUES (1861116891917975552, 0, NULL, '123d', '/user/doLogin', NULL, '[LoginDTO(username=123d, password=7c4a8d09ca3762af61e59520943dc26494f8941b)]', NULL, NULL, NULL, '0', '127.0.0.1', '2024-11-26 02:37:00', '2024-11-26 02:37:00');
INSERT INTO `user_operation_record` (`id`, `type`, `name`, `username`, `uri`, `menu`, `request`, `request_type`, `error_msg`, `cost_time`, `result`, `ip`, `create_time`, `update_time`) VALUES (1861117718866952192, 0, NULL, '123d', '/user/doLogin', NULL, '[LoginDTO(username=123d, password=7c4a8d09ca3762af61e59520943dc26494f8941b)]', NULL, NULL, NULL, '0', '127.0.0.1', '2024-11-26 02:41:00', '2024-11-26 02:41:00');
COMMIT;

-- ----------------------------
-- Table structure for user_role
-- ----------------------------
DROP TABLE IF EXISTS `user_role`;
CREATE TABLE `user_role` (
                             `id` bigint NOT NULL,
                             `user_id` bigint DEFAULT NULL COMMENT '用户id',
                             `role_id` bigint DEFAULT NULL COMMENT '角色id',
                             `create_time` timestamp NULL DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间',
                             `update_time` timestamp NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '更新时间',
                             PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci COMMENT='用户角色关联表';

-- ----------------------------
-- Records of user_role
-- ----------------------------
BEGIN;
INSERT INTO `user_role` (`id`, `user_id`, `role_id`, `create_time`, `update_time`) VALUES (1850808941676593152, 1850801224132067328, 1836575681450868736, '2024-10-28 15:56:52', '2024-10-28 15:56:52');
INSERT INTO `user_role` (`id`, `user_id`, `role_id`, `create_time`, `update_time`) VALUES (1857847465064005632, 1850812935484473344, 1836575681450868736, '2024-11-17 02:05:27', '2024-11-17 02:05:27');
INSERT INTO `user_role` (`id`, `user_id`, `role_id`, `create_time`, `update_time`) VALUES (1859278803231047680, 1853726975508611072, 1836581703372505088, '2024-11-21 00:53:05', '2024-11-21 00:53:05');
INSERT INTO `user_role` (`id`, `user_id`, `role_id`, `create_time`, `update_time`) VALUES (1859282476308889600, 1859282476250169344, 1836581703372505088, '2024-11-21 01:07:40', '2024-11-21 01:07:40');
INSERT INTO `user_role` (`id`, `user_id`, `role_id`, `create_time`, `update_time`) VALUES (1859283318923591680, 1859283318915203072, 1836581703372505088, '2024-11-21 01:11:01', '2024-11-21 01:11:01');
INSERT INTO `user_role` (`id`, `user_id`, `role_id`, `create_time`, `update_time`) VALUES (1859897951527108608, 1, 1, '2024-11-22 17:53:21', '2024-11-22 17:53:21');
COMMIT;

SET FOREIGN_KEY_CHECKS = 1;
